from __future__ import annotations
from typing import Any, List, Dict, Optional

class Annotation:
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def PersistentWidth(self, ) -> IntParameter: ...
    @property
    def PersistentHeight(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ResizeType(self) -> ResizableType: ...
    def TwoAdornersFlip(self) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def Resize(self, direction: AdornerDirection, Position: PointI) -> AdornerDirection: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def Resized(self) -> Any: ...
    def Extremities(self) -> Any: ...
    def DuplicateSymbol(self, other: Annotation) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Circuit:
    @property
    def Id(self, ) -> Any: ...
    @property
    def Devices(self, ) -> List[Any]: ...
    @property
    def Connectors(self, ) -> List[Any]: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Variables(self, ) -> List[Any]: ...
    @property
    def VariableFile(self, ) -> FilePathParameter: ...
    @property
    def Namer(self, ) -> ObjectNamer: ...
    @property
    def TrackedIDs(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Serialize(self) -> str: ...
    def Deserialize(serializedData: str) -> ICopiable: ...
    def Copy(self) -> ICopiable: ...
    def OnProjectLoaded(self) -> Any: ...
    def AddDevice(self, device: Device, location: Optional[Any] = None, rotationAngle: Optional[int] = None, rename: Optional[bool] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> Device: ...
    def AddDevice(self, deviceName: str, x: int, y: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> Device: ...
    def AddDevice(self, devType: Any, location: Optional[Any] = None, rotationAngle: Optional[int] = None) -> Device: ...
    def AddDevice(self, devType: Any, x: int, y: int, rotationAngle: Optional[int] = None) -> Device: ...
    def AddDevice(self, x: int, y: int, rotationAngle: Optional[int] = None) -> Any: ...
    def AddConnection(self, start: Pin, end: Pin) -> Connector: ...
    def AddConnection(self, start: Pin, end: PointI) -> Connector: ...
    def AddConnection(self, start: PointI, end: Pin) -> Connector: ...
    def AddConnection(self, start: PointI, end: PointI) -> Connector: ...
    def CanAddConnection(self, start: PointI, end: PointI) -> bool: ...
    def TemporaryConnector(self, start: PointI, end: PointI, additionalTemporaryDevices: Optional[List[Device]] = None, devicesToIgnore: Optional[List[Device]] = None) -> Connector: ...
    def RemoveSegmentsInArea(self, area: RectangleI) -> Any: ...
    def Remove(self, c: Connector) -> Any: ...
    def MoveItems(self, movables: List[IMovable], delta: PointI, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def MoveItem(self, movable: IMovable, newPosition: PointI) -> bool: ...
    def Remove(self, item: IMovable) -> Any: ...
    def Remove(self, items: List[Any]) -> Any: ...
    def GetModifiedPathsAfterItemMove(self, movedItems: List[Any]) -> List[Any]: ...
    def CanPlaceItemAt(self, targetArea: RectangleI, itemsToIgnore: Optional[List[Any]] = None, newpins: Optional[List[Any]] = None) -> bool: ...
    def GetDevicePinsAt(self, point: PointI) -> List[DevicePin]: ...
    def GetPinAt(self, point: Any, maxDistance: float) -> Pin: ...
    def GetConnectorSegmentsAt(self, point: PointI, extremityOnly: Optional[bool] = None) -> List[ConnectorSegment]: ...
    def GetConnectorAt(self, point: PointI) -> Connector: ...
    def GetSelectableItemAt(self, p: PointI) -> List[IMovable]: ...
    def GetSelectableItemAt(self, p: Any, maxDistance: float) -> List[IMovable]: ...
    def GetSelectableItemsIn(self, rectangle: RectangleI, entirelyInside: bool, same_footprint: Optional[bool] = None) -> List[IMovable]: ...
    def GetPinsConnectedTo(self, p: Pin) -> List[Pin]: ...
    def IsConnected(self, pin: Pin) -> bool: ...
    def GetConnectorConnectedTo(self, p: Pin) -> Connector: ...
    def GetConnectorsConnectedTo(self, d: Device) -> List[Connector]: ...
    def GetDeviceByName(self, deviceName: str) -> Device: ...
    def GetDevicesByLibraryItemName(self, libraryItemName: str) -> List[Device]: ...
    def SetVariableValue(self, variable_name: str, value: str) -> Any: ...
    def GetVariableValue(self, variable_name: str) -> str: ...
    def CircuitArea(self) -> RectangleI: ...
    def GetObjects(self) -> List[Any]: ...
    def StartRecordingChanges(self) -> Any: ...
    def Undo(self, changes: CircuitChanges) -> Any: ...
    def Redo(self, changes: CircuitChanges) -> Any: ...
    def CreateSubsystem(self, movables: List[IMovable]) -> Subcircuit: ...
    def UpdateAllSubcircuitDefinitions(self, processedDefinitionsIds: Optional[List[Any]] = None) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, circuit: Circuit): ...

class CircuitChanges:
    @property
    def ConnectorsAdded(self, ) -> Dict[Any, CopiableConnector]: ...
    @property
    def ConnectorsRemoved(self, ) -> Dict[Any, CopiableConnector]: ...
    @property
    def ConnectorsModified(self, ) -> Dict[Any, Any]: ...
    @property
    def DevicesAdded(self, ) -> Dict[Any, str]: ...
    @property
    def DevicesRemoved(self, ) -> Dict[Any, str]: ...
    @property
    def DevicesModified(self, ) -> Dict[Any, Any]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, oldState: CircuitSnapshot, newState: CircuitSnapshot, tracked_IDs: List[Any]): ...

class CircuitMap:
    def Clean(self, movables: List[IMovable]) -> List[IMovable]: ...
    def GetSelectableItemAt(self, p: PointI) -> List[IMovable]: ...
    def GetSelectableItemAt(self, p: Any, maxDistance: float) -> List[IMovable]: ...
    def GetSelectableItemsIn(self, r: RectangleI, entirelyInside: bool, same_footprint: Optional[bool] = None) -> List[IMovable]: ...
    def OnDeviceCollectionChanged(self, sender: Any, e: Any) -> Any: ...
    def OnDeviceFootprintChanged(self, device: Device, oldFootprint: RectangleI) -> Any: ...
    def OnConnectorSegmentCollectionChanged(self, sender: Any, e: Any) -> Any: ...
    def OnConnectorCollectionChanged(self, sender: Any, e: Any) -> Any: ...
    def OnItemPositionChanged(self, item: IMovable, oldFootprint: RectangleI, newFootprint: RectangleI) -> Any: ...
    def CircuitArea(self) -> RectangleI: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, circuit: Circuit): ...

class CircuitSnapshot:
    @property
    def Connectors(self, ) -> Dict[Any, CopiableConnector]: ...
    @property
    def Devices(self, ) -> Dict[Any, str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, circuit: Circuit): ...

class Connector:
    @property
    def Id(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Segments(self, ) -> List[Any]: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def GetConnectedDevicePins(self) -> List[DevicePin]: ...
    def GetLooseEnds(self) -> List[ConnectorPin]: ...
    def GetJunctions(self) -> List[PointI]: ...
    def GetConnectorSegmentsAt(self, point: PointI, extremityOnly: Optional[bool] = None) -> List[ConnectorSegment]: ...
    def GetConnectorSegmentsAt(self, point: Any, maxDistance: Optional[float] = None) -> List[ConnectorSegment]: ...
    def IsGroundConductor(self) -> bool: ...
    def CanConnectTo(self, type: SignalType) -> bool: ...
    def IsDisabled(self) -> bool: ...
    def StartUpdate(self) -> Any: ...
    def EndUpdate(self) -> List[ConnectorSegment]: ...
    def AddConnection(self, startPin: Pin, end: PointI) -> Any: ...
    def AddConnection(self, startPin: Pin, endPin: Pin) -> Any: ...
    def AddConnection(self, start: PointI, end: PointI) -> bool: ...
    def RemoveSegments(self, segments: List[Any]) -> List[ConnectorSegment]: ...
    def Clear(self) -> Any: ...
    def MergeConnector(self, oldConnector: Connector) -> Any: ...
    def SamePath(self, c: Connector) -> bool: ...
    def Type(self) -> SignalType: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def CompatibleTypes(t1: Any, t2: Any) -> bool: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, c: Circuit): ...
    def __init__(self, c: Circuit, start: PointI, end: PointI, AdditionalTemporaryDevices: Optional[List[Device]] = None, DevicesToIgnore: Optional[List[Device]] = None, fastPathFinder: Optional[bool] = None): ...

class SegmentExtremity:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ConnectorSegment:
    @property
    def Id(self, ) -> Any: ...
    @property
    def Connector(self, ) -> Connector: ...
    @property
    def StartX(self, ) -> int: ...
    @property
    def StartY(self, ) -> int: ...
    @property
    def EndX(self, ) -> int: ...
    @property
    def EndY(self, ) -> int: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Start(self, ) -> PointI: ...
    @property
    def End(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetOrientation(self) -> SegmentOrientation: ...
    def OverlappingSegment(self, segment: ConnectorSegment, intersection: Optional[bool] = None) -> Any: ...
    def CrossSegment(self, segment: ConnectorSegment) -> Any: ...
    def IsDirectlyConnectedTo(self, s: ConnectorSegment) -> bool: ...
    def ToString(self) -> str: ...
    def Move(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def Serialize(self) -> str: ...
    def Deserialize(serializedData: str) -> ICopiable: ...
    def Copy(self) -> ICopiable: ...
    def ExtremityPosition(self, extremity: SegmentExtremity) -> PointI: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, start: PointI, end: PointI, c: Connector): ...
    def __init__(self, C: Connector): ...
    def __init__(self): ...

class CopiableConnector:
    def Connector(self) -> Connector: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, connector: Connector): ...

class SegmentOrientation:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ControlDevice:
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class Design:
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def TransientAnalysis(self, ) -> TransientSolver: ...
    @property
    def SweepableItems(self, ) -> List[Any]: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, design: Design): ...

class Device:
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Deserialize(serializedData: str) -> ICopiable: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def CreateDeviceFromName(library_item_name: str) -> Device: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, c: Circuit): ...
    def __init__(self): ...

class Direction:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class FreneticDevice:
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class ICopiable:
    def Serialize(self) -> str: ...
    def Deserialize(serializedData: str) -> ICopiable: ...
    def Copy(self) -> ICopiable: ...

class IDeviceWithCodeEditor:
    def get_code(self) -> str: ...
    def set_code(self, code: str) -> Any: ...

class IDeviceWithVariablePinNumbers:
    def SetSameNumberOfPins(self, source: IDeviceWithVariablePinNumbers) -> Any: ...

class IMovable:
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...

class ResizableType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class IResizable:
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, Delta: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...

class BoolParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...
    def __init__(self, value: bool): ...

class ColorParameter:
    @property
    def Color(self, ) -> Any: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...

class DoubleArrayParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> Any: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...
    def __init__(self, value: Any): ...

class DoubleMatrixParameter:
    @property
    def NumberOfLines(self, ) -> int: ...
    @property
    def NumberOfColumns(self, ) -> int: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ValidMatrixSyntax(self) -> bool: ...
    def Set(self, value: Any) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def SequenceEquals(a: Any, b: Any) -> bool: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> Any: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: Any): ...
    def __init__(self, value: str): ...
    def __init__(self): ...
    def __init__(self, value: Any): ...

class DoubleParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> float: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...
    def __init__(self, value: float): ...

class FilePathParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...

class FolderPathParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...

class IntParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> int: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...
    def __init__(self, value: int): ...
    def __init__(self, value: bool): ...

class JMAGRT_AccuracyParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> int: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self, value: int): ...

class JMAGRT_ConnectionParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> int: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self, value: int): ...

class JMAGRT_AdvancedParameter:
    @property
    def IronLossType(self, ) -> IntParameter: ...
    @property
    def UseFilterInductance(self, ) -> bool: ...
    @property
    def FilterInductanceValue(self, ) -> DoubleParameter: ...
    @property
    def ACCopperLossType(self, ) -> IntParameter: ...
    @property
    def RotorSkewType(self, ) -> IntParameter: ...
    @property
    def StatorSkewType(self, ) -> IntParameter: ...
    @property
    def UseCorrectionFactors(self, ) -> bool: ...
    @property
    def CoefInd(self, ) -> DoubleParameter: ...
    @property
    def CoefFlux(self, ) -> DoubleParameter: ...
    @property
    def CoefTorque(self, ) -> DoubleParameter: ...
    @property
    def CoefMag(self, ) -> DoubleParameter: ...
    @property
    def CoefMat(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr1(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr2(self, ) -> DoubleParameter: ...
    @property
    def RotorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def StatorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def RotorSkewSteps(self, ) -> IntParameter: ...
    @property
    def StatorSkewSteps(self, ) -> IntParameter: ...
    @property
    def InterpolationType(self, ) -> IntParameter: ...
    @property
    def TemperatureCorrection(self, ) -> IntParameter: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JMAGRT_AdvancedParameterNoSkew:
    @property
    def IronLossType(self, ) -> IntParameter: ...
    @property
    def ACCopperLossType(self, ) -> IntParameter: ...
    @property
    def UseCorrectionFactors(self, ) -> bool: ...
    @property
    def CoefInd(self, ) -> DoubleParameter: ...
    @property
    def CoefFlux(self, ) -> DoubleParameter: ...
    @property
    def CoefTorque(self, ) -> DoubleParameter: ...
    @property
    def CoefMag(self, ) -> DoubleParameter: ...
    @property
    def CoefMat(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr1(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr2(self, ) -> DoubleParameter: ...
    @property
    def InterpolationType(self, ) -> IntParameter: ...
    @property
    def TemperatureCorrection(self, ) -> IntParameter: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NamedDoubleArrayParameter:
    @property
    def Name(self, ) -> str: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> Any: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self): ...
    def __init__(self, name: str, parameter: DoubleArrayParameter): ...

class NamedDoubleMatrixParameter:
    @property
    def Name(self, ) -> str: ...
    @property
    def NumberOfLines(self, ) -> int: ...
    @property
    def NumberOfColumns(self, ) -> int: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ValidMatrixSyntax(self) -> bool: ...
    def Set(self, value: Any) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> Any: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self): ...
    def __init__(self, name: str, parameter: DoubleMatrixParameter): ...

class NamedDoubleParameter:
    @property
    def Name(self, ) -> str: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> float: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self): ...
    def __init__(self, name: str, doubleParameter: DoubleParameter): ...

class NamedIntParameter:
    @property
    def Name(self, ) -> str: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> int: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self): ...
    def __init__(self, name: str, parameter: IntParameter): ...

class NamedStringParameter:
    @property
    def Name(self, ) -> str: ...
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self): ...
    def __init__(self, name: str, parameter: StringParameter): ...

class Parameter[T]:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...

class ParameterBase:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Clone(self) -> Any: ...
    def ToString(self) -> str: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class ParameterDisplayAttributes:
    @property
    def IsVisible(self, ) -> bool: ...
    @property
    def Suffix(self, ) -> str: ...
    @property
    def RelativeLocation(self, ) -> PointI: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def FontSize(self, ) -> int: ...
    @property
    def Color(self, ) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, param: ParameterDisplayAttributes): ...

class ParameterHelper:
    def Array2DToString(value: Any) -> str: ...
    def ResizeArray(original: Any, rows: int, cols: int, default_value: str) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class StringParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...

class SwitchStateParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> int: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self, value: int): ...

class TextParameter:
    @property
    def UserValue(self, ) -> str: ...
    @property
    def DisplayAttributes(self, ) -> ParameterDisplayAttributes: ...
    @property
    def Editable(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set(self, value: str) -> Any: ...
    def Set(self, value: Any) -> Any: ...
    def Get(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def Clone(self) -> Any: ...
    def set_display_attributes(self, is_visible: bool, left: int, top: int, width: int, height: int, suffix: Optional[str] = None) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: bool, verticalFlip: bool, itemsToIgnore: List[Any]) -> bool: ...
    def Move(self, delta: Any, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: int, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def ResizeType(self) -> ResizableType: ...
    def Resize(self, direction: AdornerDirection, resize_position: PointI) -> AdornerDirection: ...
    def Extremities(self) -> Any: ...
    def GetType(self) -> Any: ...
    def __init__(self, value: str): ...
    def __init__(self): ...

class Variable:
    @property
    def Name(self, ) -> str: ...
    @property
    def Value(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, v: Variable): ...

class VariableCollection:
    @property
    def Variables(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PathFinderNode:
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def GetType(self) -> Any: ...

class GridNode:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class PathFinderNodeType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class HeuristicFormula:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class PathFinder:
    def FindPathStop(self) -> Any: ...
    def FindPath(self, start: PointI, end: PointI, AdditionalTemporaryDevices: Optional[List[Device]] = None, DevicesToIgnore: Optional[List[Device]] = None, connectorsToIgnore: Optional[List[Connector]] = None) -> List[PathFinderNode]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, circuit: Circuit): ...
    def __init__(self, circuit: Circuit, fast: Optional[bool] = None): ...

class IPriorityQueue[T]:
    def Push(self, item: Any) -> int: ...
    def Pop(self) -> Any: ...
    def Peek(self) -> Any: ...
    def Update(self, i: int) -> Any: ...

class PriorityQueueB[T]:
    @property
    def Capacity(self, ) -> int: ...
    @property
    def Count(self, ) -> int: ...
    @property
    def Item(self, ) -> Any: ...
    def Push(self, item: Any) -> int: ...
    def Pop(self) -> Any: ...
    def Update(self, i: int) -> Any: ...
    def Peek(self) -> Any: ...
    def Clear(self) -> Any: ...
    def RemoveLocation(self, item: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, comparer: Any): ...
    def __init__(self, comparer: Any, capacity: int): ...

class ConnectorPin:
    @property
    def ConnectorSegment(self, ) -> ConnectorSegment: ...
    @property
    def Extremity(self, ) -> SegmentExtremity: ...
    @property
    def Direction(self, ) -> Direction: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Type(self, ) -> SignalType: ...
    @property
    def Size(self, ) -> int: ...
    @property
    def Name(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, type: SignalType, name: str, connectorSegment: ConnectorSegment, extremity: SegmentExtremity, size: Optional[int] = None): ...

class DevicePin:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Direction(self, ) -> Direction: ...
    @property
    def Type(self, ) -> SignalType: ...
    @property
    def Size(self, ) -> int: ...
    @property
    def Name(self, ) -> str: ...
    def UpdatePinCoordinates(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, left: int, top: int, type: SignalType, name: str, direction: Direction, device: Device, size: Optional[int] = None): ...

class Pin:
    @property
    def Type(self, ) -> SignalType: ...
    @property
    def Size(self, ) -> int: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Direction(self, ) -> Direction: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class Scope:
    @property
    def Pin_index(self, ) -> int: ...
    @property
    def Type(self, ) -> ScopeType: ...
    @property
    def Enabled(self, ) -> bool: ...
    @property
    def ID(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def BranchDeviceScopes() -> List[Scope]: ...
    def BranchThermalDeviceScopes() -> List[Scope]: ...
    def BranchMagneticDeviceScopes() -> List[Scope]: ...
    def Unit(self) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, name: str, type: ScopeType, enabled: Optional[bool] = None, pin_index: Optional[int] = None): ...

class Subcircuit:
    @property
    def Definition(self, ) -> Circuit: ...
    @property
    def Instances(self, ) -> List[Any]: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def DefinitionName(self, ) -> StringParameter: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Variables(self, ) -> List[Any]: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def MakeUnique(self) -> Any: ...
    def SetVariableValue(self, variable_name: str, value: str) -> Any: ...
    def GetVariableValue(self, variable_name: str) -> str: ...
    def DefinitionUpdated(self) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, definition: Circuit): ...

class SubcircuitDefinitionPool:
    def Add(self, circuit: Circuit) -> Any: ...
    def Get(self, id: Any) -> Circuit: ...
    def ContainsID(self, id: Any) -> bool: ...
    def Clear() -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class DesignExamples:
    def BuckConverter() -> Design: ...
    def DCDC_BuckConverter_Detailed() -> Design: ...
    def Double_Pulse_test() -> Design: ...
    def DCDC_LLC_Converter() -> Design: ...
    def ACDC_PFC_Totem_Pole() -> Design: ...
    def CukConverter() -> Design: ...
    def BLDCDrive() -> Design: ...
    def IMDrive() -> Design: ...
    def BuckBoostConverter() -> Design: ...
    def BuckBoostNonInvertingConverter() -> Design: ...
    def ACDC_3ph_DiodeBridge() -> Design: ...
    def ACDC_3ph_ThyristorBridge() -> Design: ...
    def DCDC_Forward_Converter() -> Design: ...
    def DCDC_Forward_Magnetic_Converter() -> Design: ...
    def DCDC_Boost_Converter() -> Design: ...
    def DCAC_3phase_Inverter_SPWM() -> Design: ...
    def PMSM_1() -> Design: ...
    def DCAC_5LVL_NPC() -> Design: ...
    def DCDC_Phase_Shift_Full_Bridge() -> Design: ...
    def Buck_Thermal_Tuple() -> Any: ...
    def DCDC_Flyback() -> Design: ...
    def SR_Buck() -> Design: ...
    def Interleaved_buck() -> Design: ...
    def DCDC_Dual_Active_Bridge_Converter() -> Design: ...
    def DCDC_Buck_Converter_ACSweep() -> Design: ...
    def PMSM_FullBridge() -> Design: ...
    def GetTestDesigns() -> Any: ...
    def GetACSweepTestBench(design: Design, device: ACSweepPerturbation, outputDevice: Device, outputScope: Scope) -> ACSweep: ...
    def CreateDesignExamplesRepositoryDesktop() -> Any: ...
    def CreateDesignExamplesRepositoryWeb() -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class AdornerDirection:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ArrowDirection:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class DeviceArcShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Start(self, ) -> Any: ...
    @property
    def End(self, ) -> Any: ...
    @property
    def RadiusX(self, ) -> float: ...
    @property
    def RadiusY(self, ) -> float: ...
    @property
    def RotationAngle(self, ) -> float: ...
    @property
    def SweepDirection(self, ) -> Any: ...
    @property
    def ArcSize(self, ) -> Any: ...
    @property
    def Color(self, ) -> Any: ...
    @property
    def StrokeWidth(self, ) -> float: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, startX: float, startY: float, endX: float, endY: float, radiusX: float, radiusY: float, rotationAngle: float, sweepDirection: Any, arcSize: Any, device: Device, strokeColor: Any, strokeSize: Optional[float] = None): ...
    def __init__(self, startX: float, startY: float, endX: float, endY: float, radiusX: float, radiusY: float, rotationAngle: float, sweepDirection: Any, arcSize: Any, device: Device): ...

class DeviceArrowShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Color(self, ) -> Any: ...
    @property
    def Start(self, ) -> Any: ...
    @property
    def End(self, ) -> Any: ...
    @property
    def Width(self, ) -> float: ...
    @property
    def Angle(self, ) -> float: ...
    @property
    def Ratio(self, ) -> float: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, x1: float, x2: float, y1: float, y2: float, device: Device): ...
    def __init__(self, x1: float, x2: float, y1: float, y2: float, device: Device): ...
    def __init__(self, start: Any, end: Any, device: Device): ...

class DeviceEllipseShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Center(self, ) -> Any: ...
    @property
    def RadiusX(self, ) -> float: ...
    @property
    def RadiusY(self, ) -> float: ...
    @property
    def StrokeColor(self, ) -> Any: ...
    @property
    def StrokeWidth(self, ) -> float: ...
    @property
    def FillColor(self, ) -> Any: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, centerX: float, centerY: float, radiusX: float, radiusY: float, device: Device): ...
    def __init__(self, centerX: float, centerY: float, radiusX: float, radiusY: float, device: Device): ...

class DeviceRectangleShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Point0(self, ) -> Any: ...
    @property
    def Point1(self, ) -> Any: ...
    @property
    def StrokeColor(self, ) -> Any: ...
    @property
    def StrokeWidth(self, ) -> float: ...
    @property
    def FillColor(self, ) -> Any: ...
    @property
    def Left(self, ) -> float: ...
    @property
    def Right(self, ) -> float: ...
    @property
    def Top(self, ) -> float: ...
    @property
    def Bottom(self, ) -> float: ...
    @property
    def BottomRight(self, ) -> Any: ...
    @property
    def TopLeft(self, ) -> Any: ...
    @property
    def Size(self, ) -> Any: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, left: float, top: float, right: float, bottom: float, device: Optional[Device] = None): ...
    def __init__(self, left: float, top: float, right: float, bottom: float, device: Optional[Device] = None): ...
    def __init__(self, topLeft: Any, bottomRight: Any, device: Optional[Device] = None): ...
    def __init__(self, p1: Any, p2: Any, device: Device): ...

class DeviceSegmentShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Color(self, ) -> Any: ...
    @property
    def Point0(self, ) -> Any: ...
    @property
    def Point1(self, ) -> Any: ...
    @property
    def Width(self, ) -> float: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, x1: float, x2: float, y1: float, y2: float, device: Device): ...
    def __init__(self, x1: float, x2: float, y1: float, y2: float, device: Device): ...
    def __init__(self, start: Any, end: Any, device: Device): ...

class IDeviceShape:
    @property
    def Device(self, ) -> Device: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...

class DeviceSVGShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Point0(self, ) -> Any: ...
    @property
    def Point1(self, ) -> Any: ...
    @property
    def SVG_width(self, ) -> float: ...
    @property
    def SVG_height(self, ) -> float: ...
    @property
    def SVG_d(self, ) -> str: ...
    @property
    def StrokeColor(self, ) -> Any: ...
    @property
    def StrokeWidth(self, ) -> float: ...
    @property
    def FillColor(self, ) -> Any: ...
    @property
    def Left(self, ) -> float: ...
    @property
    def Right(self, ) -> float: ...
    @property
    def Top(self, ) -> float: ...
    @property
    def Bottom(self, ) -> float: ...
    @property
    def BottomRight(self, ) -> Any: ...
    @property
    def TopLeft(self, ) -> Any: ...
    @property
    def Size(self, ) -> Any: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, left: float, top: float, right: float, bottom: float, svg_width: float, svg_height: float, d: str, device: Optional[Device] = None): ...

class DeviceTextShape:
    @property
    def TextOrientation(self, ) -> TextOrientation: ...
    @property
    def Text(self, ) -> str: ...
    @property
    def Center(self, ) -> Any: ...
    @property
    def Width(self, ) -> float: ...
    @property
    def Height(self, ) -> float: ...
    @property
    def RotateWithDevice(self, ) -> bool: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Layout(self, ) -> Any: ...
    @property
    def VerticalText(self, ) -> bool: ...
    @property
    def FontFamilyName(self, ) -> str: ...
    @property
    def FontSize(self, ) -> float: ...
    @property
    def Weight(self, ) -> Any: ...
    @property
    def Color(self, ) -> Any: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, center: Any, height: float, text: str, device: Optional[Device] = None, fontSize: Optional[float] = None): ...
    def __init__(self, center: Any, width: float, height: float, text: str, device: Optional[Device] = None, fontSize: Optional[float] = None): ...
    def __init__(self, center: Any, height: float, getText: Any, device: Optional[Device] = None, fontSize: Optional[float] = None): ...
    def __init__(self, center: Any, width: float, height: float, getText: Any, device: Optional[Device] = None, fontSize: Optional[float] = None): ...
    def __init__(self, center: Any, height: float, text: str, device: Device, fontSize: Optional[float] = None): ...
    def __init__(self, center: Any, height: float, getText: Any, device: Device, fontSize: Optional[float] = None): ...

class DeviceTriangleShape:
    @property
    def Device(self, ) -> Device: ...
    @property
    def Point0(self, ) -> Any: ...
    @property
    def Point1(self, ) -> Any: ...
    @property
    def Point2(self, ) -> Any: ...
    @property
    def StrokeColor(self, ) -> Any: ...
    @property
    def StrokeWidth(self, ) -> float: ...
    @property
    def FillColor(self, ) -> Any: ...
    @property
    def Left(self, ) -> float: ...
    @property
    def Right(self, ) -> float: ...
    @property
    def Top(self, ) -> float: ...
    @property
    def Bottom(self, ) -> float: ...
    @property
    def BottomRight(self, ) -> Any: ...
    @property
    def TopLeft(self, ) -> Any: ...
    @property
    def Size(self, ) -> Any: ...
    @property
    def Footprint(self, ) -> Any: ...
    @property
    def Alpha(self, ) -> float: ...
    @property
    def Disabled(self, ) -> bool: ...
    def UpdateCircuitCoordinates(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SetDisabled(self, disabled: bool) -> Any: ...
    def Clone(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, P1: Any, P2: Any, P3: Any, device: Device): ...

class TextOrientation:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class Geometry:
    def Distance(p1: Any, p2: Any) -> float: ...
    def Distance(p1: PointI, p2: PointI) -> float: ...
    def Distance(segmentStart: Any, segmentEnd: Any, point: Any) -> float: ...
    def Distance(segmentStart: PointI, segmentEnd: PointI, point: PointI) -> float: ...
    def Distance(segmentStart: PointI, segmentEnd: PointI, point: Any) -> float: ...
    def Dot(A: Any, B: Any, C: Any) -> float: ...
    def Dot(A: PointI, B: PointI, C: PointI) -> int: ...
    def Cross(A: Any, B: Any, C: Any) -> float: ...
    def Cross(A: PointI, B: PointI, C: PointI) -> int: ...
    def NewFootPrint(footprint: RectangleI, delta: PointI, rotationAngle: int) -> RectangleI: ...
    def TransformationMatrix(translationDelta: PointI, rotationCenter: Any, rotationAngle: int, scaleX: Optional[int] = None, scaleY: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> Any: ...
    def Displacement(direction: Direction) -> PointI: ...
    def RotateVector(vector: PointI, angle_degree: int) -> PointI: ...
    def TransformPointF(point: Any, transformationMatrix: Any) -> Any: ...
    def GetRectangleLineIntersection(rect: RectangleI, A: Any, B: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class PointI:
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def ToString(self) -> str: ...
    def GetType(self) -> Any: ...
    def __init__(self, x: int, y: int): ...

class RectangleI:
    @property
    def Left(self, ) -> int: ...
    @property
    def Right(self, ) -> int: ...
    @property
    def Top(self, ) -> int: ...
    @property
    def Bottom(self, ) -> int: ...
    @property
    def Width(self, ) -> int: ...
    @property
    def Height(self, ) -> int: ...
    @property
    def Center(self, ) -> Any: ...
    @property
    def TopLeft(self, ) -> PointI: ...
    @property
    def TopCenter(self, ) -> Any: ...
    @property
    def TopRight(self, ) -> PointI: ...
    @property
    def RightCenter(self, ) -> Any: ...
    @property
    def BottomRight(self, ) -> PointI: ...
    @property
    def BottomCenter(self, ) -> Any: ...
    @property
    def BottomLeft(self, ) -> PointI: ...
    @property
    def LeftCenter(self, ) -> Any: ...
    def Contains(self, p: Any) -> bool: ...
    def Contains(self, p: PointI, borderOnly: Optional[bool] = None) -> bool: ...
    def DistanceTo(self, point: Any) -> float: ...
    def IsContainedIn(self, r: DeviceRectangleShape) -> bool: ...
    def IsContainedIn(self, r: RectangleI) -> bool: ...
    def IsPartiallyContainedIn(self, r: DeviceRectangleShape) -> bool: ...
    def IsPartiallyContainedIn(self, r: RectangleI, ignoreBorder: Optional[bool] = None) -> bool: ...
    def TouchBorderOnly(self, r2: RectangleI) -> bool: ...
    def Intersect(self, r2: RectangleI) -> RectangleI: ...
    def Exclusion(self, P1: PointI, P2: PointI) -> List[Any]: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def GetType(self) -> Any: ...
    def __init__(self, left: int, top: int, right: int, bottom: int): ...
    def __init__(self, P1: PointI, P2: PointI): ...
    def __init__(self, location: PointI, width: int, height: int): ...

class ErrorOrWarning:
    @property
    def Status(self, ) -> Status: ...
    @property
    def Code(self, ) -> ErrorOrWarningCode: ...
    @property
    def DeviceOrConnectorName(self, ) -> str: ...
    @property
    def DeviceOrConnectorID(self, ) -> str: ...
    @property
    def ParameterName(self, ) -> str: ...
    @property
    def ParameterExpression(self, ) -> str: ...
    @property
    def CompilationError(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StatusCodeDictionary:
    def Message(errorOrWarning: ErrorOrWarning) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class FunctionsAssemblyResolver:
    def RedirectAssembly() -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CLI:
    def NewProcess(exec: str, arg: str, working_directory: str) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Documentation:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, device: Device): ...

class SubcircuitInstancePath:
    def ToString(self) -> str: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ILibraryItem:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def Childrens(self, ) -> List[Any]: ...

class Library:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def Libraries(self, ) -> List[Any]: ...
    @property
    def Devices(self, ) -> List[Any]: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def UserDefinedLibrary(self, ) -> bool: ...
    @property
    def EntityId(self, ) -> Any: ...
    def DefaultElectricalLibrary() -> Library: ...
    def DefaultFreneticLibrary() -> Library: ...
    def DefaultSubsystemPinLibrary() -> Library: ...
    def DefaultControlLibrary() -> Library: ...
    def DefaultAnnotationLibrary() -> Library: ...
    def DefaultUtilityLibrary() -> Library: ...
    def DefaultRotMechLibrary() -> Library: ...
    def DefaultThermalLibrary() -> Library: ...
    def DefaultMagneticLibrary() -> Library: ...
    def DefaultLibraries(include_deprecated: Optional[bool] = None) -> Library: ...
    def GetLibraryFromNameSpace(ns: str, include_deprecated: Optional[bool] = None) -> Library: ...
    def GetTypesInNamespace(assembly: Any, nameSpace: str) -> Any: ...
    def GetAllTypesInNamespace(ns: str) -> List[Any]: ...
    def GetDevicesinNameSpace(nameSpace: str, include_deprecated: Optional[bool] = None) -> List[Device]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class License:
    def ActivateUserAsync(username: str, password: str) -> Any: ...
    def NumberOfAvailableParallelSimulationLicense() -> int: ...
    def Activate(deployment_key: str) -> Status: ...
    def ActivateUserAsync(deployment_key: str, optional_info: Optional[Dict[str, str]] = None, persist_license: Optional[bool] = None) -> Any: ...
    def ActivateUserFromLicenseFile(path: str) -> LoginStatus: ...
    def IsLicenseValid(updateStoredLicense: bool) -> bool: ...
    def Email() -> str: ...
    def ClearStoredLicense() -> Any: ...
    def ThrowIfInvalidLicense() -> Any: ...
    def SaveLicenseRequestFile(path: str) -> Any: ...
    def LoadLicenseFile(path: str) -> Any: ...
    def MachineID() -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class EntityBase:
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ACSweep:
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Fmin(self, ) -> DoubleParameter: ...
    @property
    def SweepType(self, ) -> SweepType: ...
    @property
    def Fmax(self, ) -> DoubleParameter: ...
    @property
    def MagMin(self, ) -> DoubleParameter: ...
    @property
    def MagMax(self, ) -> DoubleParameter: ...
    @property
    def NumberOfPoints(self, ) -> IntParameter: ...
    @property
    def SaveAllSignals(self, ) -> bool: ...
    @property
    def OutputDevice(self, ) -> Device: ...
    @property
    def OutputScope(self, ) -> Scope: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Design(self, ) -> Design: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def NewJob(self, progress: Optional[Any] = None) -> Job: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, value: bool) -> Status: ...
    def RemoveAnalysisParameter(self, parameter: SolverParameter) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ParameterSweep:
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def SweepableItem(self, ) -> Any: ...
    @property
    def ParameterName(self, ) -> str: ...
    @property
    def From(self, ) -> DoubleParameter: ...
    @property
    def To(self, ) -> DoubleParameter: ...
    @property
    def NumberOfPoints(self, ) -> IntParameter: ...
    @property
    def SaveAllSignals(self, ) -> bool: ...
    @property
    def LastSignalValueVersusParameterValue(self, ) -> bool: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Design(self, ) -> Design: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def NewJob(self, progress: Optional[Any] = None) -> Job: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, value: bool) -> Status: ...
    def RemoveAnalysisParameter(self, parameter: SolverParameter) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TestBench:
    @property
    def Id(self, ) -> Any: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Device(self, ) -> Device: ...
    @property
    def Design(self, ) -> Design: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def NewJob(self, progress: Optional[Any] = None) -> Job: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, value: bool) -> Status: ...
    def RemoveAnalysisParameter(self, parameter: SolverParameter) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class Status:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class LoginStatus:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ModelType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class IntegrationMethod:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SolverType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SolverParameter:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SwitchState:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class InitializationCondition:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SignalType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SolutionVectorType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class Convention:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ScopeType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ThermalDataType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ThermalDataSemiconductorType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ThermalComputationMethodType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class SweepType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ErrorOrWarningCode:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class LogType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_AccuracyType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_InputMode:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_IronLossType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_ACCopperLossType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_Temperature:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_SkewType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_InterpolationType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_ConnectionType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class JMAG_RT_MotorType:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class Custom1DTable:
    @property
    def Name(self, ) -> str: ...
    @property
    def Xaxis(self, ) -> Any: ...
    @property
    def Data(self, ) -> Any: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def array_2d(self) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, table: Table1D): ...
    def __init__(self, table: Custom1DTable): ...

class Custom2DTable:
    @property
    def Name(self, ) -> str: ...
    @property
    def Xaxis(self, ) -> Any: ...
    @property
    def Yaxis(self, ) -> Any: ...
    @property
    def Data(self, ) -> Any: ...
    @property
    def DataSerialized(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, table: Custom2DTable): ...
    def __init__(self, table: Table2D): ...

class Custom3DTable:
    @property
    def Name(self, ) -> str: ...
    @property
    def Xaxis(self, ) -> Any: ...
    @property
    def Yaxis(self, ) -> Any: ...
    @property
    def Zaxis(self, ) -> Any: ...
    @property
    def Data(self, ) -> Any: ...
    @property
    def DataSerialized(self, ) -> Any: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def array_2d(self, z_array_index: int) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, table: Custom3DTable): ...
    def __init__(self, table: Table3D): ...
    def __init__(self, table: Custom2DTable): ...
    def __init__(self, table: Custom1DTable): ...

class EI_VT:
    @property
    def Temperature(self, ) -> float: ...
    @property
    def Voltage(self, ) -> float: ...
    @property
    def EIRaw(self, ) -> Any: ...
    @property
    def EI(self, ) -> DoubleMatrixParameter: ...
    @property
    def EISerialized(self, ) -> str: ...
    @property
    def NumberOfPoints(self, ) -> int: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Set_EI(self, ei: DoubleMatrixParameter) -> Any: ...
    def Sorted_EI(self) -> Any: ...
    def GetColumn(array: List[Any], columnNumber: int) -> List[Any]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, ei_vt: EI_VT): ...

class IV_T:
    @property
    def Temperature(self, ) -> float: ...
    @property
    def IVRaw(self, ) -> Any: ...
    @property
    def IV(self, ) -> DoubleMatrixParameter: ...
    @property
    def IVSerialized(self, ) -> str: ...
    @property
    def NumberOfPoints(self, ) -> int: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Sorted_IV(self) -> Any: ...
    def GetColumn(array: List[Any], columnNumber: int) -> List[Any]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, iv_t: IV_T): ...

class NamedThermalDataParameter:
    @property
    def ParameterName(self, ) -> str: ...
    @property
    def thermalData(self, ) -> ThermalData: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, parameterName: str, parameter: ThermalData): ...
    def __init__(self): ...

class SemiconductorLibrary:
    @property
    def Package(self, ) -> Package: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Package:
    @property
    def Class(self, ) -> str: ...
    @property
    def Vendor(self, ) -> str: ...
    @property
    def PartNumber(self, ) -> str: ...
    @property
    def ThermalModel(self, ) -> ThermalModel: ...
    @property
    def Comment(self, ) -> Comment: ...
    @property
    def Variables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def Constants(self, ) -> List[ThermalDataConstant]: ...
    @property
    def CustomTables(self, ) -> CustomTables: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CustomTables:
    @property
    def Table1Ds(self, ) -> List[Table1D]: ...
    @property
    def Table2Ds(self, ) -> List[Table2D]: ...
    @property
    def Table3Ds(self, ) -> List[Table3D]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Table1D:
    @property
    def Name(self, ) -> str: ...
    @property
    def XAxis(self, ) -> str: ...
    @property
    def FunctionValues(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Table2D:
    @property
    def Name(self, ) -> str: ...
    @property
    def XAxis(self, ) -> str: ...
    @property
    def YAxis(self, ) -> str: ...
    @property
    def YDimensions(self, ) -> List[str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Table3D:
    @property
    def Name(self, ) -> str: ...
    @property
    def XAxis(self, ) -> str: ...
    @property
    def YAxis(self, ) -> str: ...
    @property
    def ZAxis(self, ) -> str: ...
    @property
    def ZDimensions(self, ) -> List[ZDimension]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ZDimension:
    @property
    def YDimensions(self, ) -> List[str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SemiconductorData:
    @property
    def type(self, ) -> str: ...
    @property
    def TurnOnLoss(self, ) -> SwitchingLoss: ...
    @property
    def TurnOffLoss(self, ) -> SwitchingLoss: ...
    @property
    def ConductionLosses(self, ) -> List[ConductionLoss]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SwitchingLoss:
    @property
    def ComputationMethod(self, ) -> str: ...
    @property
    def CurrentAxis(self, ) -> str: ...
    @property
    def VoltageAxis(self, ) -> str: ...
    @property
    def TemperatureAxis(self, ) -> str: ...
    @property
    def Formula(self, ) -> str: ...
    @property
    def Energy(self, ) -> Energy: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Energy:
    @property
    def scale(self, ) -> str: ...
    @property
    def Temperatures(self, ) -> List[Temperature]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConductionLoss:
    @property
    def ComputationMethod(self, ) -> str: ...
    @property
    def CurrentAxis(self, ) -> str: ...
    @property
    def TemperatureAxis(self, ) -> str: ...
    @property
    def Formula(self, ) -> str: ...
    @property
    def gate(self, ) -> str: ...
    @property
    def VoltageDrop(self, ) -> VoltageDrop: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Temperature:
    @property
    def Voltage(self, ) -> List[str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VoltageDrop:
    @property
    def scale(self, ) -> str: ...
    @property
    def Temperature(self, ) -> List[str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalModel:
    @property
    def Branch(self, ) -> Branch: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Branch:
    @property
    def type(self, ) -> str: ...
    @property
    def RTauElement(self, ) -> List[RTauElement]: ...
    @property
    def RCElement(self, ) -> List[RCElement]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RTauElement:
    @property
    def R(self, ) -> str: ...
    @property
    def Tau(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RCElement:
    @property
    def R(self, ) -> str: ...
    @property
    def C(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Comment:
    @property
    def Lines(self, ) -> List[str]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalData:
    @property
    def Name(self, ) -> str: ...
    @property
    def Manufacturer(self, ) -> str: ...
    @property
    def PartNumber(self, ) -> str: ...
    @property
    def Comment(self, ) -> str: ...
    @property
    def ConductionLossesGateDependency(self, ) -> bool: ...
    @property
    def SemiconductorType(self, ) -> ThermalDataSemiconductorType: ...
    @property
    def ThermalImpedanceType(self, ) -> ThermalDataType: ...
    @property
    def ConductionLosses(self, ) -> List[Any]: ...
    @property
    def ConductionLossesGateOff(self, ) -> List[Any]: ...
    @property
    def TurnOnLosses(self, ) -> List[Any]: ...
    @property
    def TurnOffLosses(self, ) -> List[Any]: ...
    @property
    def CustomVariables(self, ) -> List[Any]: ...
    @property
    def Constants(self, ) -> List[Any]: ...
    @property
    def Custom1DTables(self, ) -> List[Any]: ...
    @property
    def Custom2DTables(self, ) -> List[Any]: ...
    @property
    def Custom3DTables(self, ) -> List[Any]: ...
    @property
    def ConductionLossComputationMethod(self, ) -> ThermalComputationMethodType: ...
    @property
    def ConductionLossComputationFormula(self, ) -> str: ...
    @property
    def ConductionLossComputationMethodGateOff(self, ) -> ThermalComputationMethodType: ...
    @property
    def ConductionLossComputationFormulaGateOff(self, ) -> str: ...
    @property
    def TurnOnLossComputationMethod(self, ) -> ThermalComputationMethodType: ...
    @property
    def TurnOnLossComputationFormula(self, ) -> str: ...
    @property
    def TurnOffLossComputationMethod(self, ) -> ThermalComputationMethodType: ...
    @property
    def TurnOnLossComputationFormulaTitle(self, ) -> str: ...
    @property
    def TurnOffLossComputationFormulaTitle(self, ) -> str: ...
    @property
    def ConductionLossComputationFormulaTitle(self, ) -> str: ...
    @property
    def TurnOffLossComputationFormula(self, ) -> str: ...
    @property
    def ThermalImpedanceData(self, ) -> Any: ...
    @property
    def ThermalImpedanceDataSerialized(self, ) -> str: ...
    @property
    def NumberOfImpedanceDataPoints(self, ) -> int: ...
    @property
    def ID(self, ) -> Any: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ToString(self) -> str: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, description: ThermalData): ...
    def __init__(self): ...
    def __init__(self, path: str): ...
    def __init__(self, package: Package): ...

class ThermalDataConstant:
    @property
    def Name(self, ) -> str: ...
    @property
    def Value(self, ) -> str: ...
    @property
    def Description(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, c: ThermalDataConstant): ...

class ThermalDataVariable:
    @property
    def Name(self, ) -> str: ...
    @property
    def Value(self, ) -> str: ...
    @property
    def Description(self, ) -> str: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, v: ThermalDataVariable): ...

class ThermalDevice:
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class IProjectRepository:
    @property
    def Project(self, ) -> SerializableProject: ...
    def GetDesigns(self) -> List[Design]: ...
    def GetDesignByName(self, name: str) -> Design: ...
    def AddDesign(self, Design: Design, updateName: Optional[bool] = None) -> Any: ...
    def RemoveDesign(self, Design: Design) -> Any: ...
    def AddResults(self, Results: TransientAnalysisJob) -> TransientAnalysisJob: ...
    def GetTransientAnalysisJobs(self) -> List[TransientAnalysisJob]: ...
    def FilePath(self) -> str: ...
    def RemoveResult(self, Results: TransientAnalysisJob) -> Any: ...
    def GetLibraries(self) -> List[Library]: ...
    def RemoveLibrary(self, library: Library) -> Any: ...
    def AddLibrary(self, library: Library) -> Library: ...
    def ReloadAsync(self, path: Optional[str] = None) -> Any: ...
    def IsTemporary(self) -> bool: ...
    def SaveAs(self, newPath: str) -> Any: ...
    def Save(self) -> Any: ...
    def UnsavedChanges(self) -> bool: ...
    def GetTestBenches(self) -> List[TestBench]: ...
    def GetACSweepByName(self, name: str) -> ACSweep: ...
    def AddTestBench(self, testBench: TestBench) -> Any: ...
    def RemoveTestBench(self, testBench: TestBench) -> Any: ...
    def GetThermalData(self) -> List[ThermalData]: ...
    def GetThermalDataByName(self, name: str) -> ThermalData: ...
    def AddThermalData(self, thermalData: ThermalData) -> Any: ...
    def RemoveThermalData(self, thermalData: ThermalData) -> Any: ...

class JsonProjectRepository:
    @property
    def Project(self, ) -> SerializableProject: ...
    def ReloadAsync(self, path: Optional[str] = None) -> Any: ...
    def UnsavedChanges(self) -> bool: ...
    def FilePath(self) -> str: ...
    def IsTemporary(self) -> bool: ...
    def SaveAs(self, path: str) -> Any: ...
    def Save(self) -> Any: ...
    def GetProjectJson(self) -> str: ...
    def GetDesigns(self) -> List[Design]: ...
    def GetDesignByName(self, name: str) -> Design: ...
    def AddDesign(self, design: Design, updateName: Optional[bool] = None) -> Any: ...
    def RemoveDesign(self, design: Design) -> Any: ...
    def AddResults(self, results: TransientAnalysisJob) -> TransientAnalysisJob: ...
    def GetTransientAnalysisJobs(self) -> List[TransientAnalysisJob]: ...
    def RemoveResult(self, Results: TransientAnalysisJob) -> Any: ...
    def GetLibraries(self) -> List[Library]: ...
    def RemoveLibrary(self, library: Library) -> Any: ...
    def AddLibrary(self, library: Library) -> Library: ...
    def GetTestBenches(self) -> List[TestBench]: ...
    def GetACSweepByName(self, name: str) -> ACSweep: ...
    def AddTestBench(self, testBench: TestBench) -> Any: ...
    def RemoveTestBench(self, testBench: TestBench) -> Any: ...
    def GetThermalData(self) -> List[ThermalData]: ...
    def AddThermalData(self, thermalData: ThermalData) -> Any: ...
    def RemoveThermalData(self, thermalData: ThermalData) -> Any: ...
    def GetThermalDataByName(self, name: str) -> ThermalData: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, path: Optional[str] = None): ...

class ProjectRepository:
    @property
    def Project(self, ) -> SerializableProject: ...
    def AddDesign(self, Design: Design, updateName: Optional[bool] = None) -> Any: ...
    def AddLibrary(self, library: Library) -> Library: ...
    def AddResults(self, Results: TransientAnalysisJob) -> TransientAnalysisJob: ...
    def AddTestBench(self, testBench: TestBench) -> Any: ...
    def AddThermalData(self, thermalData: ThermalData) -> Any: ...
    def FilePath(self) -> str: ...
    def GetACSweepByName(self, name: str) -> ACSweep: ...
    def GetDesignByName(self, name: str) -> Design: ...
    def GetDesigns(self) -> List[Design]: ...
    def GetLibraries(self) -> List[Library]: ...
    def GetTestBenches(self) -> List[TestBench]: ...
    def GetThermalData(self) -> List[ThermalData]: ...
    def GetThermalDataByName(self, name: str) -> ThermalData: ...
    def GetTransientAnalysisJobs(self) -> List[TransientAnalysisJob]: ...
    def IsTemporary(self) -> bool: ...
    def ReloadAsync(self, path: Optional[str] = None) -> Any: ...
    def RemoveDesign(self, Design: Design) -> Any: ...
    def RemoveLibrary(self, library: Library) -> Any: ...
    def RemoveResult(self, Results: TransientAnalysisJob) -> Any: ...
    def RemoveTestBench(self, testBench: TestBench) -> Any: ...
    def RemoveThermalData(self, thermalData: ThermalData) -> Any: ...
    def Save(self) -> Any: ...
    def SaveAs(self, newPath: str) -> Any: ...
    def UnsavedChanges(self) -> bool: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, path: str): ...

class SerializableProject:
    @property
    def Designs(self, ) -> List[Design]: ...
    @property
    def Libraries(self, ) -> List[Library]: ...
    @property
    def Results(self, ) -> List[TransientAnalysisJob]: ...
    @property
    def TestBenches(self, ) -> List[TestBench]: ...
    @property
    def ThermalData(self, ) -> List[ThermalData]: ...
    @property
    def Unsaved_changes(self, ) -> bool: ...
    @property
    def Namer(self, ) -> ObjectNamer: ...
    def GetObjects(self) -> List[Any]: ...
    def GetDesigns(self) -> List[Design]: ...
    def GetDesignByName(self, name: str) -> Design: ...
    def GetThermalDataByName(self, name: str) -> ThermalData: ...
    def AddDesign(self, Design: Design, updateName: Optional[bool] = None) -> Any: ...
    def RemoveDesign(self, design: Design) -> Any: ...
    def GetTransientAnalysisJobs(self) -> List[TransientAnalysisJob]: ...
    def AddResults(self, result: TransientAnalysisJob) -> TransientAnalysisJob: ...
    def RemoveResult(self, result: TransientAnalysisJob) -> Any: ...
    def GetLibraries(self) -> List[Library]: ...
    def AddLibrary(self, library: Library) -> Library: ...
    def RemoveLibrary(self, library: Library) -> Any: ...
    def GetTestBenches(self) -> List[TestBench]: ...
    def GetACSweepByName(self, name: str) -> ACSweep: ...
    def AddTestBench(self, testBench: TestBench) -> Any: ...
    def RemoveTestBench(self, testBench: TestBench) -> Any: ...
    def GetThermalData(self) -> List[ThermalData]: ...
    def AddThermalData(self, thermalData: ThermalData) -> Any: ...
    def RemoveThermalData(self, thermalData: ThermalData) -> Any: ...
    def OnProjectLoaded(self, json_project: bool) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JsonSerializationOptionsSingleton:
    @property
    def SubcircuitDeepCopy() -> bool: ...
    @property
    def Instance() -> Any: ...
    def ResetSubcircuitDefinitionProcessed() -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class DeviceConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Clear(self) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def Write(self, writer: Any, device: Device, options: Any) -> Any: ...
    def GetDeviceParameters(self, device: Device) -> Dict[str, ParameterBase]: ...
    def SetDeviceParameters(self, device: Device, parameters: Dict[str, str]) -> Any: ...
    def WriteAsPropertyName(self, writer: Any, value: Device, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TestBenchConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def Write(self, writer: Any, testbench: TestBench, options: Any) -> Any: ...
    def WriteAsPropertyName(self, writer: Any, value: TestBench, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StringNullableEnumConverter[T]:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def Write(self, writer: Any, value: Any, options: Any) -> Any: ...
    def WriteAsPropertyName(self, writer: Any, value: Any, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, options: Any): ...

class DoubleParameterConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: DoubleParameter, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: DoubleParameter, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class BoolParameterConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: BoolParameter, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: BoolParameter, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IntParameterConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: IntParameter, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: IntParameter, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FilePathParameterConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: FilePathParameter, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: FilePathParameter, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalDataTypeConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: ThermalDataType, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: ThermalDataType, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ColorConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: Any, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: Any, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PointIConverter:
    @property
    def HandleNull(self, ) -> bool: ...
    @property
    def Type(self, ) -> Any: ...
    def Write(self, writer: Any, value: PointI, options: Any) -> Any: ...
    def CanConvert(self, typeToConvert: Any) -> bool: ...
    def WriteAsPropertyName(self, writer: Any, value: PointI, options: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RecentProject:
    @property
    def Name(self, ) -> str: ...
    @property
    def Path(self, ) -> str: ...
    @property
    def LastUpdate(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RecentProjects:
    @property
    def Projects(self, ) -> List[Any]: ...
    @property
    def NoRecentProject(self, ) -> bool: ...
    def Add(self, path: str, lastUpdate: Any) -> Any: ...
    def Remove(self, path: str) -> Any: ...
    def SerializeToXML(self) -> str: ...
    def LoadFromXML(XMLString: str) -> RecentProjects: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Json_Import_Object:
    @property
    def libraries(self, ) -> List[psim_library]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class psim_library:
    @property
    def name(self, ) -> str: ...
    @property
    def components_with_no_change(self, ) -> List[components_with_no_change]: ...
    @property
    def components_using_subcircuit(self, ) -> List[components_using_subcircuit]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_components:
    @property
    def psim_type(self, ) -> str: ...
    @property
    def simba_library_item_name(self, ) -> str: ...
    @property
    def coord(self, ) -> simba_coordinates: ...
    @property
    def nodes_index_in_Simba(self, ) -> List[int]: ...
    @property
    def comment(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class components_with_no_change:
    @property
    def has_device_alternative(self, ) -> List[str]: ...
    @property
    def simba_parameters(self, ) -> List[simba_parameters]: ...
    @property
    def psim_type(self, ) -> str: ...
    @property
    def simba_library_item_name(self, ) -> str: ...
    @property
    def coord(self, ) -> simba_coordinates: ...
    @property
    def nodes_index_in_Simba(self, ) -> List[int]: ...
    @property
    def comment(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class components_using_subcircuit:
    @property
    def has_device_alternative(self, ) -> List[str]: ...
    @property
    def pin_to_check(self, ) -> int: ...
    @property
    def subcircuit_parameters(self, ) -> List[simba_parameters_in_subcircuit]: ...
    @property
    def simba_device(self, ) -> Device: ...
    @property
    def psim_type(self, ) -> str: ...
    @property
    def simba_library_item_name(self, ) -> str: ...
    @property
    def coord(self, ) -> simba_coordinates: ...
    @property
    def nodes_index_in_Simba(self, ) -> List[int]: ...
    @property
    def comment(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_parameters:
    @property
    def simba_name(self, ) -> str: ...
    @property
    def type(self, ) -> str: ...
    @property
    def formula(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_parameters_in_subcircuit:
    @property
    def device_name_in_subcircuit(self, ) -> str: ...
    @property
    def simba_name(self, ) -> str: ...
    @property
    def type(self, ) -> str: ...
    @property
    def formula(self, ) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_coordinates:
    @property
    def simba_rotation_offset_clockwise_in_degree(self, ) -> int: ...
    @property
    def simba_flip_offset(self, ) -> simba_flip_offset: ...
    @property
    def simba_location_offset_in_simba_ref(self, ) -> simba_location_offset_in_simba_ref: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_flip_offset:
    @property
    def horizontal_offset(self, ) -> int: ...
    @property
    def vertical_offset(self, ) -> int: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class simba_location_offset_in_simba_ref:
    @property
    def x(self, ) -> int: ...
    @property
    def y(self, ) -> int: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PsimImporter:
    def CreateSIMBARepositoryFromPSIMFile(xml_path: str) -> Any: ...
    def ImportAndTryDifferentScales(xml_path: str) -> Any: ...
    def Import(xml_path: str, json_dictionary: Json_Import_Object, xml_content: PsimSchematic) -> Any: ...
    def ExtractPsimSimbaJsonFile(ErrorsAndWarnings: List[ErrorOrWarning]) -> Json_Import_Object: ...
    def FindSimbaComponentFromPsimType(dictionary: Json_Import_Object, type: str) -> components_with_no_change: ...
    def IsNotManagedType(type_to_find: str) -> bool: ...
    def FindSimbaSubcircuitFromPsimType(dictionary: Json_Import_Object, type: str) -> components_using_subcircuit: ...
    def CheckHybridComponents(json_dictionary: Json_Import_Object, component: PsimComponent, simba_component_rules: components_with_no_change) -> components_with_no_change: ...
    def CheckHybridComponents(json_dictionary: Json_Import_Object, component: PsimComponent, simba_subcircuit_rules: components_using_subcircuit) -> components_using_subcircuit: ...
    def CreateTheWireSketch(circuit: Circuit, cCircuit: CCircuit, ErrorsAndWarnings: List[ErrorOrWarning]) -> Any: ...
    def SortedByPinLocation(dictionary: Dict[DevicePin, PinProperties]) -> Dict[PointI, List[DevicePin]]: ...
    def SortedByPinNodeName(dictionary: Dict[DevicePin, PinProperties]) -> Dict[int, List[DevicePin]]: ...
    def CreateTheSimbaDevice(circuit: Circuit, temp_device: Device, component: PsimComponent, simba_component_rules: simba_components) -> Device: ...
    def SetDeviceParameters(device: Device, parameters: Dict[str, str]) -> Any: ...
    def GetDeviceParameters(device: Device) -> Dict[str, str]: ...
    def CreateTheSubcircuitPort(circuit: Circuit, subcircuit_port: CNode, pin: Pin) -> List[ErrorOrWarning]: ...
    def NewCoordinates(coordinates: int) -> int: ...
    def NewCoordinatesScale(coordinates: int, scale: int) -> int: ...
    def CleanConstantAndExpressionName(str: str) -> str: ...
    def AddConverterBefore(circuit: Circuit, pin: DevicePin, converter_type: str) -> Device: ...
    def AddConverterAfter(circuit: Circuit, pin: DevicePin, converter_type: str) -> Device: ...
    def AddDeviceAndTryDifferentLocations(circuit: Circuit, device: Device, location: PointI, rotationAngle: int, rename: bool, horizontalFlip: bool, verticalFlip: bool) -> Device: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class PsimSchematic:
    @property
    def CTimer(self, ) -> CTimer: ...
    @property
    def TI_DMC_VERSION(self, ) -> int: ...
    @property
    def CCircuit(self, ) -> CCircuit: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CTimer:
    @property
    def ENGINE_DEFAULT(self, ) -> Engine_Default: ...
    @property
    def DSED(self, ) -> Dsed: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Engine_Default:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Dsed:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CCircuit:
    @property
    def Components(self, ) -> List[PsimComponent]: ...
    @property
    def DLL_EXT(self, ) -> List[DLL_EXT]: ...
    @property
    def DLL_EXT_MAG(self, ) -> List[DLL_EXT]: ...
    @property
    def Wires(self, ) -> List[Wire]: ...
    @property
    def V_FEM(self, ) -> List[V_FEM]: ...
    @property
    def L_FEM(self, ) -> List[L_FEM]: ...
    @property
    def SubCircuits(self, ) -> List[PsimSubcircuit]: ...
    @property
    def Ports(self, ) -> List[Port]: ...
    @property
    def Ignored(self, ) -> List[List[Any]]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class GenericComponent:
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PsimComponent:
    @property
    def Coord(self, ) -> Coord: ...
    @property
    def Area(self, ) -> Area: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DLL_EXT:
    @property
    def InNodes(self, ) -> List[Node]: ...
    @property
    def OutNodes(self, ) -> List[Node]: ...
    @property
    def ExternalPath(self, ) -> str: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PsimSubcircuit:
    @property
    def CCircuit(self, ) -> CCircuit: ...
    @property
    def Coord(self, ) -> Coord: ...
    @property
    def Area(self, ) -> Area: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class V_FEM:
    @property
    def OutNodes(self, ) -> List[Node]: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class L_FEM:
    @property
    def OutNodes(self, ) -> List[Node]: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DLL_EXT_MAG:
    @property
    def InNodes(self, ) -> List[Node]: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    @property
    def Params(self, ) -> List[Param]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Port:
    @property
    def Coord(self, ) -> Coord: ...
    @property
    def Area(self, ) -> Area: ...
    @property
    def CNodes(self, ) -> List[CNode]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Coord:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Area:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CNode:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Param:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Wire:
    @property
    def Segment(self, ) -> Segment: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Segment:
    @property
    def X_Y_coordinates(self, ) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Node:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class INamed:
    @property
    def Prefix(self, ) -> str: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...

class INamedObjectsOwner:
    @property
    def Namer(self, ) -> ObjectNamer: ...
    def GetObjects(self) -> List[Any]: ...

class ObjectNamer:
    @property
    def ObjectOwner(self, ) -> Any: ...
    def SetName(self, obj: INamed) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, objectOwner: INamedObjectsOwner): ...

class ControlInConnectorLabel:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlOutConnectorLabel:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ElectricalConnectorLabel:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RotationalMechanicalConnectorLabel:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalConnectorLabel:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class UnknownDevice:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantTemperature:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Temperature(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledHeatSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledTemperatureSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledTemperatureSourceSmall:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearTemperatureSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def TimeValueMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StepTemperatureSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def FinalValue(self, ) -> DoubleParameter: ...
    @property
    def StepTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalGround:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalCapacitor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def Vinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalControlledResistor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalResistor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class HeatFlowMeter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class HeatFlowProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TemperatureMeter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TemperatureProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlInPin:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlOutPin:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ElectricalPin:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RotationalMechanicalPin:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ThermalPin:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SpeedProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TorqueProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantPowerLoad:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Tmax(self, ) -> DoubleParameter: ...
    @property
    def Wbase(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantSpeed:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Voltage(self, ) -> DoubleParameter: ...
    @property
    def Speed(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantTorque:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledSpeed:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledTorque:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class GenericLoad:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def T0(self, ) -> DoubleParameter: ...
    @property
    def T1(self, ) -> DoubleParameter: ...
    @property
    def T2(self, ) -> DoubleParameter: ...
    @property
    def T3(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantFluxRateSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def FluxRate(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ConstantMMFSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def MMF(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class MagneticGround:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FluxProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class MMFProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class AirGap:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def RelativePermeability(self, ) -> DoubleParameter: ...
    @property
    def Area(self, ) -> DoubleParameter: ...
    @property
    def Length(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class LinearCore:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def RelativePermeability(self, ) -> DoubleParameter: ...
    @property
    def Area(self, ) -> DoubleParameter: ...
    @property
    def Length(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Permeance:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def MMFinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Winding:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def NumberOfTurns(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FreneticIdealTransformer:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def Ratio(self, ) -> DoubleParameter: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FreneticIdealTransformer3Winding:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def W3P(self, ) -> DevicePin: ...
    @property
    def W3N(self, ) -> DevicePin: ...
    @property
    def Ratio21(self, ) -> DoubleParameter: ...
    @property
    def Ratio31(self, ) -> DoubleParameter: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FreneticIdealTransformerMultiWinding:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def NumberOfWindings(self, ) -> IntParameter: ...
    @property
    def NumberOfTurns(self, ) -> DoubleArrayParameter: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FreneticInductor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def Iinit(self, ) -> DoubleParameter: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FreneticSaturableInductor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def ApparentInductance(self, ) -> DoubleMatrixParameter: ...
    @property
    def Iinit(self, ) -> DoubleParameter: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfExportedPeriods(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfWindings(self) -> int: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealTransformer:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def Ratio(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealTransformer3Winding:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def W3P(self, ) -> DevicePin: ...
    @property
    def W3N(self, ) -> DevicePin: ...
    @property
    def Ratio21(self, ) -> DoubleParameter: ...
    @property
    def Ratio31(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealTransformerMultiWinding:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def NumberOfWindings(self, ) -> IntParameter: ...
    @property
    def NumberOfTurns(self, ) -> DoubleArrayParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealTransformerWithControlledRatio:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def Ratio(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NonIdealTransformer:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def W1P(self, ) -> DevicePin: ...
    @property
    def W1N(self, ) -> DevicePin: ...
    @property
    def W2P(self, ) -> DevicePin: ...
    @property
    def W2N(self, ) -> DevicePin: ...
    @property
    def Ratio(self, ) -> DoubleParameter: ...
    @property
    def Rp(self, ) -> DoubleParameter: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Lp(self, ) -> DoubleParameter: ...
    @property
    def Ls(self, ) -> DoubleParameter: ...
    @property
    def Lm(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledSwitch:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledSwitchWithThreshold:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def OnValue(self, ) -> DoubleParameter: ...
    @property
    def OffValue(self, ) -> DoubleParameter: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Switch:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def State(self, ) -> SwitchStateParameter: ...
    @property
    def T1(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SpiceNetlist:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Netlist(self, ) -> TextParameter: ...
    @property
    def Node_names(self, ) -> StringParameter: ...
    @property
    def Scope_names(self, ) -> StringParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def get_node_names(self) -> List[str]: ...
    def get_scopes_names(self) -> List[str]: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def get_code(self) -> str: ...
    def set_code(self, code: str) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ACCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Phase(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ACVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Phase(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledVoltageSourceSmall:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> Pin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CurrentControlledCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def CP(self, ) -> DevicePin: ...
    @property
    def CN(self, ) -> Pin: ...
    @property
    def P(self, ) -> Pin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CurrentControlledVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def CP(self, ) -> DevicePin: ...
    @property
    def CN(self, ) -> Pin: ...
    @property
    def P(self, ) -> Pin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DCCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Current(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DCVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Voltage(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DeprectedACCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Phase(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DeprecatedACVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Phase(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Ground:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Pin(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NonLinearCurrentSourceGeneric:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> Pin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def Expression(self, ) -> StringParameter: ...
    @property
    def NumberOfVoltageVariables(self, ) -> IntParameter: ...
    @property
    def NumberOfCurrentVariables(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NonLinearVoltageSourceGeneric:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> Pin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def Expression(self, ) -> StringParameter: ...
    @property
    def NumberOfVoltageVariables(self, ) -> IntParameter: ...
    @property
    def NumberOfCurrentVariables(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NonLinearVoltageSourceProduct:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> Pin: ...
    @property
    def N(self, ) -> Pin: ...
    @property
    def P1(self, ) -> DevicePin: ...
    @property
    def N1(self, ) -> Pin: ...
    @property
    def P2(self, ) -> Pin: ...
    @property
    def N2(self, ) -> Pin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def TimeValueMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def TimeValueMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StepCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def FinalValue(self, ) -> DoubleParameter: ...
    @property
    def StepTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StepVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def FinalValue(self, ) -> DoubleParameter: ...
    @property
    def StepTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VariableGainVoltageControlledVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def CP(self, ) -> DevicePin: ...
    @property
    def CN(self, ) -> DevicePin: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VoltageControlledCurrentSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def CP(self, ) -> DevicePin: ...
    @property
    def CN(self, ) -> DevicePin: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VoltageControlledVoltageSource:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def CP(self, ) -> DevicePin: ...
    @property
    def CN(self, ) -> DevicePin: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Diode_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Anode(self, ) -> Pin: ...
    @property
    def Cathode(self, ) -> Pin: ...
    @property
    def Vt(self, ) -> DoubleParameter: ...
    @property
    def Is(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealDiode_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def Rd(self, ) -> DoubleParameter: ...
    @property
    def Vf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealIGBT_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Collector(self, ) -> DevicePin: ...
    @property
    def Emitter(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def Vf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealMOSFET_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class MosfetWithDiode_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def Rdon(self, ) -> DoubleParameter: ...
    @property
    def Vdf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearDiode:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def Vf_If_Matrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def C_Vr_Matrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearInternalMosfet:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Vgs_threshold(self, ) -> DoubleParameter: ...
    @property
    def K(self, ) -> DoubleParameter: ...
    @property
    def Lambda(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinearMosfet:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Rg(self, ) -> DoubleParameter: ...
    @property
    def VgsIdMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def VgsIdMatrix_Vds(self, ) -> DoubleParameter: ...
    @property
    def VdsIdMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def VdsIdMatrix_Vgs(self, ) -> DoubleParameter: ...
    @property
    def Ciss(self, ) -> DoubleMatrixParameter: ...
    @property
    def Coss(self, ) -> DoubleMatrixParameter: ...
    @property
    def Crss(self, ) -> DoubleMatrixParameter: ...
    @property
    def Vsd_Is_BodyDiodeMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Thyristor_Deprecated:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DetailedDiode:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def Vf_If_Matrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def C_Vr_Matrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def Vinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DetailedMOSFETDatasheet:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Rg(self, ) -> DoubleParameter: ...
    @property
    def VgsIdMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def VgsIdMatrix_Vds(self, ) -> DoubleParameter: ...
    @property
    def VdsIdMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def VdsIdMatrix_Vgs(self, ) -> DoubleParameter: ...
    @property
    def Ciss(self, ) -> DoubleMatrixParameter: ...
    @property
    def Coss(self, ) -> DoubleMatrixParameter: ...
    @property
    def Crss(self, ) -> DoubleMatrixParameter: ...
    @property
    def VgsInit(self, ) -> DoubleParameter: ...
    @property
    def VdsInit(self, ) -> DoubleParameter: ...
    @property
    def Vsd_Is_BodyDiodeMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DetailedMOSFETSpiceVDMOS:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Spice_Netlist(self, ) -> TextParameter: ...
    @property
    def VgsInit(self, ) -> DoubleParameter: ...
    @property
    def VdsInit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealDiode:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def Rd(self, ) -> DoubleParameter: ...
    @property
    def Vf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealIGBT:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Collector(self, ) -> DevicePin: ...
    @property
    def Emitter(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def Vf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealMOSFET:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealMosfetWithDiode:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Drain(self, ) -> DevicePin: ...
    @property
    def Source(self, ) -> DevicePin: ...
    @property
    def Gate(self, ) -> DevicePin: ...
    @property
    def Ron(self, ) -> DoubleParameter: ...
    @property
    def Rdon(self, ) -> DoubleParameter: ...
    @property
    def Vdf(self, ) -> DoubleParameter: ...
    @property
    def LossesPin(self, ) -> DevicePin: ...
    @property
    def JunctionTemperatureControlPin(self, ) -> DevicePin: ...
    @property
    def InitialTemperature(self, ) -> DoubleParameter: ...
    @property
    def ShowJunctionTemperatureControlPin(self, ) -> BoolParameter: ...
    @property
    def ThermalData(self, ) -> ThermalData: ...
    @property
    def CustomVariables(self, ) -> List[ThermalDataVariable]: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IdealThyristor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Anode(self, ) -> DevicePin: ...
    @property
    def Cathode(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CurrentMeter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CurrentProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DifferentialVoltageMeter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DifferentialVoltageProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PowerProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_1L(self, ) -> DevicePin: ...
    @property
    def Pin_2L(self, ) -> DevicePin: ...
    @property
    def Pin_1R(self, ) -> DevicePin: ...
    @property
    def Pin_2R(self, ) -> DevicePin: ...
    @property
    def Pin_P(self, ) -> DevicePin: ...
    @property
    def Pin_Q(self, ) -> DevicePin: ...
    @property
    def Pin_S(self, ) -> DevicePin: ...
    @property
    def Pin_PF(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PowerProbe3Phases:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_LA(self, ) -> DevicePin: ...
    @property
    def Pin_LB(self, ) -> DevicePin: ...
    @property
    def Pin_LC(self, ) -> DevicePin: ...
    @property
    def Pin_RA(self, ) -> DevicePin: ...
    @property
    def Pin_RB(self, ) -> DevicePin: ...
    @property
    def Pin_RC(self, ) -> DevicePin: ...
    @property
    def Pin_P(self, ) -> DevicePin: ...
    @property
    def Pin_Q(self, ) -> DevicePin: ...
    @property
    def Pin_S(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VoltageMeter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class VoltageProbe:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Gain(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class BLDC:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_N(self, ) -> DevicePin: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Ld(self, ) -> DoubleMatrixParameter: ...
    @property
    def Lq(self, ) -> DoubleMatrixParameter: ...
    @property
    def Ke(self, ) -> DoubleParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def InitialCurrent(self, ) -> DoubleArrayParameter: ...
    @property
    def NPP(self, ) -> IntParameter: ...
    @property
    def ExposeNeutralPoint(self, ) -> BoolParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class IM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Ls(self, ) -> DoubleParameter: ...
    @property
    def Rr(self, ) -> DoubleMatrixParameter: ...
    @property
    def Lr(self, ) -> DoubleMatrixParameter: ...
    @property
    def Lm(self, ) -> DoubleParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialCurrent(self, ) -> DoubleArrayParameter: ...
    @property
    def NPP(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JmagRT_IM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_Pcore(self, ) -> DevicePin: ...
    @property
    def Pin_Pwinding(self, ) -> DevicePin: ...
    @property
    def Pin_Pcage(self, ) -> DevicePin: ...
    @property
    def RttCalculatorLibraryFilePath(self, ) -> StringParameter: ...
    @property
    def AdvancedParameters(self, ) -> JMAGRT_AdvancedParameter: ...
    @property
    def IronLossType(self, ) -> IntParameter: ...
    @property
    def UseFilterInductance(self, ) -> IntParameter: ...
    @property
    def FilterInductanceValue(self, ) -> DoubleParameter: ...
    @property
    def ACCopperLossType(self, ) -> IntParameter: ...
    @property
    def RotorSkewType(self, ) -> IntParameter: ...
    @property
    def StatorSkewType(self, ) -> IntParameter: ...
    @property
    def RotorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def StatorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def RotorSkewSteps(self, ) -> IntParameter: ...
    @property
    def StatorSkewSteps(self, ) -> IntParameter: ...
    @property
    def UseCorrection(self, ) -> IntParameter: ...
    @property
    def CoefInd(self, ) -> DoubleParameter: ...
    @property
    def CoefFlux(self, ) -> DoubleParameter: ...
    @property
    def CoefTorque(self, ) -> DoubleParameter: ...
    @property
    def CoefMat(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr1(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr2(self, ) -> DoubleParameter: ...
    @property
    def InterpolationType(self, ) -> IntParameter: ...
    @property
    def TemperatureCorrection(self, ) -> IntParameter: ...
    @property
    def RttFilePath(self, ) -> FilePathParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def NPP(self, ) -> IntParameter: ...
    @property
    def AverageLossCalcFreq(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JmagRT_PMSM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_Pcore(self, ) -> DevicePin: ...
    @property
    def Pin_Pwinding(self, ) -> DevicePin: ...
    @property
    def Pin_Pmagnet(self, ) -> DevicePin: ...
    @property
    def RttCalculatorLibraryFilePath(self, ) -> StringParameter: ...
    @property
    def AdvancedParameters(self, ) -> JMAGRT_AdvancedParameter: ...
    @property
    def IronLossType(self, ) -> IntParameter: ...
    @property
    def UseFilterInductance(self, ) -> IntParameter: ...
    @property
    def FilterInductanceValue(self, ) -> DoubleParameter: ...
    @property
    def ACCopperLossType(self, ) -> IntParameter: ...
    @property
    def RotorSkewType(self, ) -> IntParameter: ...
    @property
    def StatorSkewType(self, ) -> IntParameter: ...
    @property
    def RotorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def StatorSkewAngle(self, ) -> DoubleParameter: ...
    @property
    def RotorSkewSteps(self, ) -> IntParameter: ...
    @property
    def StatorSkewSteps(self, ) -> IntParameter: ...
    @property
    def UseCorrection(self, ) -> IntParameter: ...
    @property
    def CoefInd(self, ) -> DoubleParameter: ...
    @property
    def CoefFlux(self, ) -> DoubleParameter: ...
    @property
    def CoefTorque(self, ) -> DoubleParameter: ...
    @property
    def CoefMag(self, ) -> DoubleParameter: ...
    @property
    def CoefMat(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr1(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr2(self, ) -> DoubleParameter: ...
    @property
    def InterpolationType(self, ) -> IntParameter: ...
    @property
    def TemperatureCorrection(self, ) -> IntParameter: ...
    @property
    def RttFilePath(self, ) -> FilePathParameter: ...
    @property
    def AccuracyType(self, ) -> JMAGRT_AccuracyParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def ConnectionType(self, ) -> JMAGRT_ConnectionParameter: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def AverageLossCalcFreq(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JmagRT_WFSM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_F(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_Pcore(self, ) -> DevicePin: ...
    @property
    def Pin_Pwinding(self, ) -> DevicePin: ...
    @property
    def RttCalculatorLibraryFilePath(self, ) -> StringParameter: ...
    @property
    def AdvancedParameters(self, ) -> JMAGRT_AdvancedParameterNoSkew: ...
    @property
    def IronLossType(self, ) -> IntParameter: ...
    @property
    def ACCopperLossType(self, ) -> IntParameter: ...
    @property
    def UseCorrection(self, ) -> IntParameter: ...
    @property
    def CoefInd(self, ) -> DoubleParameter: ...
    @property
    def CoefFlux(self, ) -> DoubleParameter: ...
    @property
    def CoefTorque(self, ) -> DoubleParameter: ...
    @property
    def CoefMag(self, ) -> DoubleParameter: ...
    @property
    def CoefMat(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr1(self, ) -> DoubleParameter: ...
    @property
    def TurnCorr2(self, ) -> DoubleParameter: ...
    @property
    def InterpolationType(self, ) -> IntParameter: ...
    @property
    def TemperatureCorrection(self, ) -> IntParameter: ...
    @property
    def RttFilePath(self, ) -> FilePathParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def ConnectionType(self, ) -> JMAGRT_ConnectionParameter: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Rf(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def AverageLossCalcFreq(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PMSM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_N(self, ) -> DevicePin: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Ld(self, ) -> DoubleMatrixParameter: ...
    @property
    def Lq(self, ) -> DoubleMatrixParameter: ...
    @property
    def Ke(self, ) -> DoubleParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def InitialCurrent(self, ) -> DoubleArrayParameter: ...
    @property
    def NPP(self, ) -> IntParameter: ...
    @property
    def ExposeNeutralPoint(self, ) -> BoolParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SynRM:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Pin_A(self, ) -> DevicePin: ...
    @property
    def Pin_B(self, ) -> DevicePin: ...
    @property
    def Pin_C(self, ) -> DevicePin: ...
    @property
    def Pin_R(self, ) -> DevicePin: ...
    @property
    def Pin_Angle(self, ) -> DevicePin: ...
    @property
    def Pin_N(self, ) -> DevicePin: ...
    @property
    def Rs(self, ) -> DoubleParameter: ...
    @property
    def Ld(self, ) -> DoubleMatrixParameter: ...
    @property
    def Lq(self, ) -> DoubleMatrixParameter: ...
    @property
    def J(self, ) -> DoubleParameter: ...
    @property
    def B(self, ) -> DoubleParameter: ...
    @property
    def InitialSpeed(self, ) -> DoubleParameter: ...
    @property
    def InitialCurrent(self, ) -> DoubleArrayParameter: ...
    @property
    def NPP(self, ) -> IntParameter: ...
    @property
    def ExposeNeutralPoint(self, ) -> BoolParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Capacitor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def Vinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CommonModeChoke:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def CommonModeInductance(self, ) -> DoubleParameter: ...
    @property
    def LeakageInductance(self, ) -> DoubleParameter: ...
    @property
    def WindingResistance(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledCapacitor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Vinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledResistor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class CoupledInductor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def NumberOfWindings(self, ) -> IntParameter: ...
    @property
    def Inductance(self, ) -> DoubleMatrixParameter: ...
    @property
    def Iinit(self, ) -> DoubleArrayParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Inductor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def Iinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PieceWiseLinearResistor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def VoltageCurrentMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Resistor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ResistorWithLosses:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def Losses(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def LossCalculationFrequency(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SaturableCapacitor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def ApparentCapacitance(self, ) -> DoubleMatrixParameter: ...
    @property
    def Vinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SaturableInductor:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def P(self, ) -> DevicePin: ...
    @property
    def N(self, ) -> DevicePin: ...
    @property
    def ApparentInductance(self, ) -> DoubleMatrixParameter: ...
    @property
    def Iinit(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ABC2AlphaBetaGamma:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def Alpha(self, ) -> DevicePin: ...
    @property
    def Beta(self, ) -> DevicePin: ...
    @property
    def Gamma(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ABC2DQ0:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class AlphaBetaGamma2ABC:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Alpha(self, ) -> DevicePin: ...
    @property
    def Beta(self, ) -> DevicePin: ...
    @property
    def Gamma(self, ) -> DevicePin: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class AlphaBetaGamma2DQ0:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Alpha(self, ) -> DevicePin: ...
    @property
    def Beta(self, ) -> DevicePin: ...
    @property
    def Gamma(self, ) -> DevicePin: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DQ02ABC:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DQ02AlphaBetaGamma:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def Alpha(self, ) -> DevicePin: ...
    @property
    def Beta(self, ) -> DevicePin: ...
    @property
    def Gamma(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class InvPark:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Park:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def A(self, ) -> DevicePin: ...
    @property
    def B(self, ) -> DevicePin: ...
    @property
    def C(self, ) -> DevicePin: ...
    @property
    def Angle(self, ) -> DevicePin: ...
    @property
    def D(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def Zero(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class LookupTable1D:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Table(self, ) -> DoubleMatrixParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class LookupTable2D:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def InX(self, ) -> DevicePin: ...
    @property
    def InY(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def XValues(self, ) -> DoubleArrayParameter: ...
    @property
    def YValues(self, ) -> DoubleArrayParameter: ...
    @property
    def Table(self, ) -> DoubleMatrixParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ACSweepPerturbation:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> Pin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Constant:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> Pin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledPWMGenerator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Frequency(self, ) -> DevicePin: ...
    @property
    def DutyCycle(self, ) -> DevicePin: ...
    @property
    def PhaseShift(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def RiseTime(self, ) -> DoubleParameter: ...
    @property
    def FallTime(self, ) -> DoubleParameter: ...
    @property
    def MinimalFrequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledSawtoothWaveGenerator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Frequency(self, ) -> DevicePin: ...
    @property
    def PhaseShift(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def MinimalFrequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ControlledTriangularWaveGenerator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Frequency(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def MinimalFrequency(self, ) -> DoubleParameter: ...
    @property
    def DutyCycle(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PiecewiseLinear:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def TimeValueMatrix(self, ) -> DoubleMatrixParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SawtoothWave:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def PhaseShift(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SinusoidalWave:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def PhaseShift(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SquareWave:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Period(self, ) -> DoubleParameter: ...
    @property
    def OnTime(self, ) -> DoubleParameter: ...
    @property
    def Delay(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SquareWave2:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def DutyCycle(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def PhaseShift(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Step:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def FinalValue(self, ) -> DoubleParameter: ...
    @property
    def StepTime(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TriangularWave:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Period(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def Delay(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TriangularWave2:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Amplitude(self, ) -> DoubleParameter: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def DutyCycle(self, ) -> DoubleParameter: ...
    @property
    def Offset(self, ) -> DoubleParameter: ...
    @property
    def PhaseShift(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class AbsoluteValue:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Average:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def Initial(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Comparator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ComparatorWithHysteresis:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Hysteresis(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Cosine:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Cos:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Division:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Gain:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Value(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Limiter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def LowLimit(self, ) -> DoubleParameter: ...
    @property
    def HighLimit(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Modulo:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Divisor(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Product:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RangeLimiter:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def LowLimit(self, ) -> DoubleParameter: ...
    @property
    def HighLimit(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RootMeanSquare:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Sine:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Sinus:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SquareRoot:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Sum:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def Gains(self, ) -> DoubleArrayParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Tangent:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class UserDefinedExpression:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def i1(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def Expression(self, ) -> StringParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Monostable:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Rising(self, ) -> DevicePin: ...
    @property
    def Falling(self, ) -> DevicePin: ...
    @property
    def PulseWidth(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def notQ(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class AndGate:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class JKFlipFlop:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def J(self, ) -> DevicePin: ...
    @property
    def K(self, ) -> DevicePin: ...
    @property
    def clock(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def notQ(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class NotGate:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class OrGate:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SignalSelector:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def i1(self, ) -> DevicePin: ...
    @property
    def i2(self, ) -> DevicePin: ...
    @property
    def Selector(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class SRFlipFlop:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def S(self, ) -> DevicePin: ...
    @property
    def R(self, ) -> DevicePin: ...
    @property
    def Q(self, ) -> DevicePin: ...
    @property
    def notQ(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class XorGate:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In1(self, ) -> DevicePin: ...
    @property
    def In2(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DeadTime:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def RisingEdgeDelay(self, ) -> DoubleParameter: ...
    @property
    def FallingEdgeDelay(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Delay:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def DelayLength(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DigitalIntegrator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def Lower(self, ) -> DoubleParameter: ...
    @property
    def Upper(self, ) -> DoubleParameter: ...
    @property
    def WrappedMode(self, ) -> BoolParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DiscreteTransferFunction:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Num(self, ) -> DoubleArrayParameter: ...
    @property
    def Den(self, ) -> DoubleArrayParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class InternalResettableDigitalIntegrator:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def Lower(self, ) -> DoubleParameter: ...
    @property
    def Upper(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Memory:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Relay:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def UpperThreshold(self, ) -> DoubleParameter: ...
    @property
    def LowerThreshold(self, ) -> DoubleParameter: ...
    @property
    def OnStateOutput(self, ) -> DoubleParameter: ...
    @property
    def OffStateOutput(self, ) -> DoubleParameter: ...
    @property
    def InitialState(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class THD:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Frequency(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ZeroCrossingDetector:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ZeroOrderHold:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class FirstOrderTransferFunction:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def K(self, ) -> DoubleParameter: ...
    @property
    def Tau(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class GenericTransferFunction:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Num(self, ) -> DoubleArrayParameter: ...
    @property
    def Den(self, ) -> DoubleArrayParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Integral:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def TimeConstant(self, ) -> DoubleParameter: ...
    @property
    def Lower(self, ) -> DoubleParameter: ...
    @property
    def Upper(self, ) -> DoubleParameter: ...
    @property
    def WrappedMode(self, ) -> BoolParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class PID:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def Kp(self, ) -> DoubleParameter: ...
    @property
    def Kd(self, ) -> DoubleParameter: ...
    @property
    def Ki(self, ) -> DoubleParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ResettableIntegral:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def In(self, ) -> DevicePin: ...
    @property
    def Out(self, ) -> DevicePin: ...
    @property
    def InitialValue(self, ) -> DoubleParameter: ...
    @property
    def TimeConstant(self, ) -> DoubleParameter: ...
    @property
    def Lower(self, ) -> DoubleParameter: ...
    @property
    def Upper(self, ) -> DoubleParameter: ...
    @property
    def WrappedMode(self, ) -> BoolParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class C_Code_External:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def SourceFilePath(self, ) -> FilePathParameter: ...
    @property
    def OptionalAdditionalIncludeDirectory(self, ) -> FolderPathParameter: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def NumberOfOutputs(self, ) -> IntParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def Compile_and_set_path(self) -> ErrorOrWarning: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class C_Code:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def NumberOfOutputs(self, ) -> IntParameter: ...
    @property
    def OptionalAdditionalIncludeDirectory(self, ) -> FolderPathParameter: ...
    @property
    def Code(self, ) -> StringParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def NeedToInstallCompiler() -> bool: ...
    def Compile_and_set_path(self) -> ErrorOrWarning: ...
    def GetCompilerPath(quotify: Optional[bool] = None) -> str: ...
    def InstallCompiler() -> bool: ...
    def Library_HeaderFilePath() -> str: ...
    def GetDeterministicHashCode(str: str) -> int: ...
    def NativeLibraryExtension() -> Any: ...
    def Clean_Library_Folder() -> Any: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def get_code(self) -> str: ...
    def set_code(self, code: str) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ExternalLibrary:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def LibraryFilePath(self, ) -> FilePathParameter: ...
    @property
    def NumberOfInputs(self, ) -> IntParameter: ...
    @property
    def NumberOfOutputs(self, ) -> IntParameter: ...
    @property
    def SamplingTime(self, ) -> DoubleParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def PathWithoutExtension(self) -> str: ...
    def SetSameNumberOfPins(self, obj: IDeviceWithVariablePinNumbers) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ArrowAnnotation:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def Width(self, ) -> DoubleParameter: ...
    @property
    def Direction(self, ) -> IntParameter: ...
    @property
    def Color(self, ) -> ColorParameter: ...
    @property
    def PersistentWidth(self, ) -> IntParameter: ...
    @property
    def PersistentHeight(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ResizeType(self) -> ResizableType: ...
    def Extremities(self) -> Any: ...
    def DuplicateSymbol(self, other: Annotation) -> Any: ...
    def TwoAdornersFlip(self) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def Resize(self, direction: AdornerDirection, Position: PointI) -> AdornerDirection: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def Resized(self) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class RectangleAnnotation:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def BorderWidth(self, ) -> DoubleParameter: ...
    @property
    def BorderColor(self, ) -> ColorParameter: ...
    @property
    def PersistentWidth(self, ) -> IntParameter: ...
    @property
    def PersistentHeight(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def DuplicateSymbol(self, other: Annotation) -> Any: ...
    def ResizeType(self) -> ResizableType: ...
    def TwoAdornersFlip(self) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def Resize(self, direction: AdornerDirection, Position: PointI) -> AdornerDirection: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def Resized(self) -> Any: ...
    def Extremities(self) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class TextAnnotation:
    @property
    def LibraryItemName(self, ) -> str: ...
    @property
    def ModelType(self, ) -> ModelType: ...
    @property
    def Prefix(self, ) -> str: ...
    @property
    def Pins(self, ) -> List[Any]: ...
    @property
    def Shapes(self, ) -> List[Any]: ...
    @property
    def Scopes(self, ) -> List[Scope]: ...
    @property
    def FontSize(self, ) -> DoubleParameter: ...
    @property
    def BorderWidth(self, ) -> DoubleParameter: ...
    @property
    def Text(self, ) -> TextParameter: ...
    @property
    def TextColor(self, ) -> ColorParameter: ...
    @property
    def BorderColor(self, ) -> ColorParameter: ...
    @property
    def PersistentWidth(self, ) -> IntParameter: ...
    @property
    def PersistentHeight(self, ) -> IntParameter: ...
    @property
    def InstanceID(self, ) -> Any: ...
    @property
    def UndoTrackingId(self, ) -> Any: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def DeviceToCircuitMatrixTransform(self, ) -> Any: ...
    @property
    def CircuitToDeviceMatrixTransform(self, ) -> Any: ...
    @property
    def UnrotatedTop(self, ) -> int: ...
    @property
    def UnrotatedLeft(self, ) -> int: ...
    @property
    def UnrotatedWidth(self, ) -> int: ...
    @property
    def UnrotatedHeight(self, ) -> int: ...
    @property
    def RotationAngle(self, ) -> int: ...
    @property
    def HorizontallyFlipped(self, ) -> bool: ...
    @property
    def VerticallyFlipped(self, ) -> bool: ...
    @property
    def Deprecated(self, ) -> bool: ...
    @property
    def Disabled(self, ) -> bool: ...
    @property
    def IsBeta(self, ) -> bool: ...
    @property
    def Childrens(self, ) -> List[Any]: ...
    @property
    def LibraryItemPath(self, ) -> str: ...
    @property
    def ParameterShapes(self, ) -> List[Any]: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def Footprint(self, ) -> RectangleI: ...
    @property
    def PositionUnrotated(self, ) -> PointI: ...
    @property
    def Position(self, ) -> PointI: ...
    @property
    def DocumentationURL(self, ) -> Documentation: ...
    @property
    def ObservableScopes(self, ) -> List[Any]: ...
    @property
    def Additional_Data(self, ) -> Dict[str, List[str]]: ...
    @property
    def Name(self, ) -> StringParameter: ...
    @property
    def EntityId(self, ) -> Any: ...
    def DuplicateSymbol(self, other: Annotation) -> Any: ...
    def Resized(self) -> Any: ...
    def ResizeType(self) -> ResizableType: ...
    def TwoAdornersFlip(self) -> Any: ...
    def CanMove(self, delta: Any, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def Resize(self, direction: AdornerDirection, Position: PointI) -> AdornerDirection: ...
    def Resize(self, new_left: int, new_top: int, new_width: int, new_height: int) -> Any: ...
    def Extremities(self) -> Any: ...
    def Move(self, delta: Optional[Any] = None, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def Move(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None) -> bool: ...
    def CanMove(self, deltaX: int, deltaY: int, rotationAngle: Optional[int] = None, horizontalFlip: Optional[bool] = None, verticalFlip: Optional[bool] = None, itemsToIgnore: Optional[List[Any]] = None) -> bool: ...
    def SetName(self, name: str) -> Any: ...
    def GetName(self) -> str: ...
    def Serialize(self) -> str: ...
    def Copy(self) -> ICopiable: ...
    def RotateLeft(self) -> Any: ...
    def HorizontalFlip(self) -> Any: ...
    def VerticalFlip(self) -> Any: ...
    def RotateRight(self) -> Any: ...
    def SetColors(self, type: SignalType) -> Any: ...
    def SameTypeAndFootprint(self, d: Device) -> bool: ...
    def UpdateObservableScopes(self) -> Any: ...
    def ParametersUpdated(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class StringExtensions:
    def Quotify(s: str) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class ReleaseInfo:
    @property
    def VersionName(self, ) -> str: ...
    @property
    def Version(self, ) -> str: ...
    @property
    def DownloadUrl(self, ) -> str: ...
    @property
    def ReleaseNoteUrl(self, ) -> str: ...
    def GetReleasesAsync() -> Any: ...
    def GetLatestRelease(releases: Dict[str, ReleaseInfo]) -> ReleaseInfo: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ArrayHelper:
    def ToString(value: Any) -> str: ...
    def SortByFirstColumn(array: List[Any], comparer: Optional[Any] = None) -> List[Any]: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class AssemblyVersion:
    def GetVersion() -> str: ...
    def GetVersionShort() -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class DeviceTypeLookup:
    def GetDeviceFromLibraryItemName(self, item_name: str) -> Device: ...
    def UpdateDeprecatedItemName(item_name: str) -> str: ...
    def GetType(self, item_name: str) -> Any: ...
    def RegisterDeviceType(self, device: Device) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class GuidExtensions:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class SolverLibrary:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class DefaultColors:
    @property
    def ElectricalDevice() -> Any: ...
    @property
    def ControlDevice() -> Any: ...
    @property
    def RotationalMechanicalDevice() -> Any: ...
    @property
    def ThermalDevice() -> Any: ...
    @property
    def MagneticDevice() -> Any: ...
    @property
    def MagneticLightFillDevice() -> Any: ...
    @property
    def AutomaticType() -> Any: ...
    @property
    def DeviceFillColor() -> Any: ...
    @property
    def CircuitBackground() -> Any: ...
    @property
    def MouseOverBackgroundFill() -> Any: ...
    @property
    def ItemSelectedBackgroundFill() -> Any: ...
    @property
    def AdornerStroke() -> Any: ...
    @property
    def AdornerFill() -> Any: ...
    @property
    def TextTooSmallFillColor() -> Any: ...
    @property
    def ItemSelectedStroke() -> Any: ...
    @property
    def RubberBandSelectionBackgroundFill() -> Any: ...
    @property
    def RubberBandSelectionStroke() -> Any: ...
    @property
    def BackgroundGrid() -> Any: ...
    @property
    def ContextMenuFill() -> Any: ...
    @property
    def ContextMenuStroke() -> Any: ...
    @property
    def ZoomMenuFill() -> Any: ...
    @property
    def ZoomMenuStroke() -> Any: ...
    def HexToColor(hexString: str) -> Any: ...
    def ColorToHex(c: Any) -> str: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class ExecuteCommandDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def Invoke(self, command: Any, param: Optional[Any] = None) -> Any: ...
    def BeginInvoke(self, command: Any, param: Any, callback: Any, object: Any) -> Any: ...
    def EndInvoke(self, result: Any) -> Any: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class CanExecuteCommandDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def Invoke(self, command: Any) -> bool: ...
    def BeginInvoke(self, command: Any, callback: Any, object: Any) -> Any: ...
    def EndInvoke(self, result: Any) -> bool: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class GetFocusDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def Invoke(self) -> Any: ...
    def BeginInvoke(self, callback: Any, object: Any) -> Any: ...
    def EndInvoke(self, result: Any) -> Any: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class SetCursorDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def Invoke(self, cursor: Cursors) -> Any: ...
    def BeginInvoke(self, cursor: Cursors, callback: Any, object: Any) -> Any: ...
    def EndInvoke(self, result: Any) -> Any: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class Cursors:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class CircuitControl:
    @property
    def CircuitDrawer(self, ) -> CircuitDrawer: ...
    @property
    def DoubleClickTimeoutInMs(self, ) -> int: ...
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def CanvasDrawingUpdatePaused(self, ) -> bool: ...
    @property
    def SelectedElements(self, ) -> List[Any]: ...
    @property
    def PendingElements(self, ) -> List[Any]: ...
    @property
    def AddPendingElementsToCircuit(self, ) -> Any: ...
    @property
    def MoveCommand(self, ) -> Any: ...
    @property
    def AddConnectionCommand(self, ) -> Any: ...
    @property
    def CutCommand(self, ) -> Any: ...
    @property
    def PasteCommand(self, ) -> Any: ...
    @property
    def DuplicateCommand(self, ) -> Any: ...
    @property
    def SelectAllCommand(self, ) -> Any: ...
    @property
    def ClearClipboardCommand(self, ) -> Any: ...
    @property
    def CopyCommand(self, ) -> Any: ...
    @property
    def RotateLeftCommand(self, ) -> Any: ...
    @property
    def RotateRightCommand(self, ) -> Any: ...
    @property
    def HorizontalFlipCommand(self, ) -> Any: ...
    @property
    def VerticalFlipCommand(self, ) -> Any: ...
    @property
    def DeleteCommand(self, ) -> Any: ...
    @property
    def OpenCommand(self, ) -> Any: ...
    @property
    def MakeUniqueCommand(self, ) -> Any: ...
    @property
    def ZoomToFitCommand(self, ) -> Any: ...
    @property
    def ZoomInCommand(self, ) -> Any: ...
    @property
    def ConnectCommand(self, ) -> Any: ...
    @property
    def CancelActionCommand(self, ) -> Any: ...
    @property
    def AddLabelCommand(self, ) -> Any: ...
    @property
    def ZoomOutCommand(self, ) -> Any: ...
    @property
    def HideParameterCommand(self, ) -> Any: ...
    @property
    def EnableCommand(self, ) -> Any: ...
    @property
    def DisableCommand(self, ) -> Any: ...
    @property
    def CreateSubsystemCommand(self, ) -> Any: ...
    def SetContextMenuCommands(self) -> Any: ...
    def UpdateContextMenuCommands(self) -> Any: ...
    def SetZoomMenuCommands(self) -> Any: ...
    def ZoomIn(self) -> Any: ...
    def ZoomOut(self) -> Any: ...
    def ZoomToFit(self) -> Any: ...
    def Connect(self) -> Any: ...
    def AddLabel(self) -> Any: ...
    def CancelAction(self) -> Any: ...
    def CanvasMouseWheel(self, delta: float, x: float, y: float) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, canvas: Any, executeCommandDelegate: ExecuteCommandDelegate, canExecuteCommandDelegate: CanExecuteCommandDelegate, getFocus: GetFocusDelegate, setCursor: SetCursorDelegate, support_code: bool, support_subcircuit: bool): ...

class CircuitDrawer:
    @property
    def Circuit(self, ) -> Circuit: ...
    @property
    def MouseOverElement(self, ) -> IMovable: ...
    @property
    def MouseOverPin(self, ) -> Pin: ...
    @property
    def Target(self, ) -> Any: ...
    def UpdateTemporaryElements(self, temporaryItems: Optional[List[IMovable]] = None) -> Any: ...
    def UpdateSelectedElements(self, SelectedElements: List[Any]) -> Any: ...
    def AdornerAt(self, x: float, y: float, item: IResizable) -> Any: ...
    def StartSelection(self, x: float, y: float) -> Any: ...
    def IsSelectionStarted(self) -> bool: ...
    def RubberbandSelectionExists(self) -> bool: ...
    def SelectionInProgress(self, x: float, y: float) -> Any: ...
    def EndSelection(self) -> Any: ...
    def BeginUpdate(self) -> Any: ...
    def EndUpdate(self) -> Any: ...
    def Redraw(self) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, canvas: Any): ...

class ContextMenuDrawer:
    @property
    def Commands(self, ) -> Dict[str, Any]: ...
    def UseSmallIcons(self) -> Any: ...
    def UseLargeIcons(self) -> Any: ...
    def Hide(self) -> Any: ...
    def Show(self, location: Any) -> Any: ...
    def Location(self, selectedItems: List[Any]) -> Any: ...
    def Location(self, ItemLodaction: Any) -> Any: ...
    def UpdateMousePosition(self, mousePosition: Any) -> Any: ...
    def OnMouseLeftButtonDown(self, mousePosition: Any) -> bool: ...
    def OnMouseUp(self, mousePosition: Any) -> bool: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, canvas: Any, executeCommand: ExecuteCommandDelegate): ...

class ZoomMenuDrawer:
    def UpdateZoomMenu(self, location: Any) -> Any: ...
    def UpdateMousePosition(self, mousePosition: Any) -> Any: ...
    def OnMouseLeftButtonDown(self, mousePosition: Any) -> bool: ...
    def OnMouseUp(self, mousePosition: Any) -> bool: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, canvas: Any, executeCommand: ExecuteCommandDelegate): ...

class ACSweepTestBenchJob:
    @property
    def FrequencyPoints(self, ) -> Any: ...
    @property
    def TransientSolver(self, ) -> TransientSolver: ...
    @property
    def TimePoints(self, ) -> Any: ...
    @property
    def SolverType(self, ) -> SolverType: ...
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Dispose(self) -> Any: ...
    def ClearScopesData(self) -> Status: ...
    def ClearScopesData(self, start_time: float) -> Status: ...
    def GetSignalByScopeID(self, scopeGUID: str) -> Signal: ...
    def GetSignalByName(self, signalName: str) -> Signal: ...
    def Run(self) -> Status: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, name: str, testbench: ACSweep, progress: Optional[Any] = None): ...

class Analysis:
    @property
    def Design(self, ) -> Design: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, value: bool) -> Status: ...
    def RemoveAnalysisParameter(self, parameter: SolverParameter) -> Status: ...
    def IsCalculationProgressing(s: Status) -> bool: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, design: Design): ...

class AnalysisProgress:
    @property
    def Progress(self, ) -> float: ...
    @property
    def Status(self, ) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class Constants:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class DFTSettingsMode:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class DFTSettings:
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, stepFrequencyInHz: float, numberOfAnalysedPeriod: int, numberOfHarmonics: int): ...
    def __init__(self, minTimeInS: float, maxTimeInS: float, numberOfHarmonics: int): ...

class DFTCalculatorJob:
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Run(self) -> Status: ...
    def GetIndexes(self) -> Dict[Signal, int]: ...
    def Dispose(self) -> Any: ...
    def Stop(self) -> Status: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, dFTSettings: DFTSettings, selectedSignals: List[Signal], progress: Optional[Any] = None): ...

class Helper:
    def IsGroundOrConnectorLabel(d: Device) -> bool: ...
    def ID(device: Device, circuitDestinationGuid: Optional[str] = None) -> str: ...
    def ID(connector: Connector) -> str: ...
    def IsGround(d: Device) -> bool: ...
    def SubcircuitPinId(subcircuit: Subcircuit, pin: DevicePin) -> str: ...
    def SingleConnectionID(pin: DevicePin, connectedPins: List[DevicePin]) -> str: ...
    def GetObjectNameFromSubcircuitPath(circuit: Circuit, path: str) -> str: ...
    def BoolToString(value: bool) -> str: ...
    def IsSubclassOfGenericType(type_to_check: Any, generic_type: Any) -> bool: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...

class CSVFormat:
    def HasFlag(self, flag: Any) -> bool: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def CompareTo(self, target: Any) -> int: ...
    def ToString(self) -> str: ...
    def ToString(self, format: str) -> str: ...
    def ToString(self, provider: Any) -> str: ...
    def ToString(self, format: str, provider: Any) -> str: ...
    def GetTypeCode(self) -> Any: ...
    def GetType(self) -> Any: ...

class ImportSignalFileJob:
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Run(self) -> Status: ...
    def Dispose(self) -> Any: ...
    def Stop(self) -> Status: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, importFilePath: str, csvFormat: Optional[CSVFormat] = None, progress: Optional[Any] = None): ...

class UpdateProgressDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def Invoke(self, status: Status, progress: float, errorAndWarning: ErrorOrWarning) -> Any: ...
    def BeginInvoke(self, status: Status, progress: float, errorAndWarning: ErrorOrWarning, callback: Any, object: Any) -> Any: ...
    def EndInvoke(self, result: Any) -> Any: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class ISolverNativeBridge:
    @property
    def ErrorsAndWarnings(self, ) -> List[ErrorOrWarning]: ...
    def SetUpdateProgressDelegate(self, updateProgressDelegate: Optional[UpdateProgressDelegate] = None) -> Any: ...
    def AddDevice(self, modelType: ModelType, guid: str, subcircuitID: Optional[str] = None, subcircuiDefinitiontID: Optional[str] = None) -> Status: ...
    def SetDeviceParameter(self, deviceID: str, parameterName: str, expression: str, subcircuitID: Optional[str] = None) -> Status: ...
    def SetConnection(self, deviceID: str, pinName: str, connectorID: str, subcircuitID: Optional[str] = None) -> Status: ...
    def SetVariable(self, variable_name: str, variable_expression: str, subcircuit_definition_id: Optional[str] = None, subcircuit_instance_id: Optional[str] = None) -> Status: ...
    def SetScope(self, deviceID: str, scopeID: str, scopeType: ScopeType, controlPinIndex: int, subcircuitID: Optional[str] = None) -> Status: ...
    def ClearScopesData(self, clear_all: bool, start_time: float) -> Status: ...
    def ConfigureScopeMemory(self, scopeGuid: str, unique_time_scope: Optional[bool] = None) -> Status: ...
    def Solve(self) -> Status: ...
    def Stop(self) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, parameter_expression: str) -> Status: ...
    def SetThermalData(self, thermalDataID: str, type: ThermalDataType, array1: DoubleArrayParameter, array2: DoubleArrayParameter, temperature: float, voltage: float) -> Status: ...
    def SetThermalDataComputationMethod(self, thermalDataID: str, thermalDataType: ThermalDataType, thermalComputationMethodType: ThermalComputationMethodType, Formula: Optional[str] = None) -> Status: ...
    def SetThermalDataCustomTable(self, thermalDataID: str, customTableName: str, axis_0: DoubleArrayParameter, axis_1: DoubleArrayParameter, axis_2: DoubleArrayParameter, data: Any) -> Status: ...
    def CheckCircuitConsistency(self) -> Status: ...
    def SetLogLevel(self, log_type: LogType, log_level: int) -> Status: ...
    def DisposeNativeSolver(self) -> Any: ...

class Job:
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def Run(self) -> Status: ...
    def Dispose(self) -> Any: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ParametricTestBenchJob:
    @property
    def StopRequested(self, ) -> bool: ...
    @property
    def ParameterName(self, ) -> str: ...
    @property
    def Jobs(self, ) -> List[Any]: ...
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Run(self) -> Status: ...
    def Dispose(self) -> Any: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, name: str, jobs: List[Any], saveAllSignals: bool, parameterName: str, lastValueVsParameterValue: bool, progress: Optional[Any] = None): ...

class Parser:
    def Dispose(self) -> Any: ...
    def DefineVariable(self, variableName: str, variableExpression: str) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...

class ScopeMemory:
    def Resize(self, new_allocated_size: int) -> Any: ...
    def Dispose(self) -> Any: ...
    def GetSize(self) -> int: ...
    def ExecuteInLock(self, action: Any) -> Any: ...
    def GetValue(self, index: int) -> float: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, initial_allocated_size: int): ...

class Signal:
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Unit(self, ) -> str: ...
    @property
    def SamplingTime(self, ) -> Any: ...
    @property
    def XName(self, ) -> str: ...
    @property
    def XUnit(self, ) -> str: ...
    @property
    def XLogarithmicScale(self, ) -> bool: ...
    @property
    def ScopeId(self, ) -> str: ...
    @property
    def TransientAnalysisResults(self, ) -> TransientAnalysisJob: ...
    @property
    def DataPoints(self, ) -> Any: ...
    @property
    def TimePoints(self, ) -> Any: ...
    @property
    def EntityId(self, ) -> Any: ...
    def Get_Y_Pointer(self, action: Any) -> Status: ...
    def Get_X_Pointer(self, action: Any) -> Status: ...
    def ToString(self) -> str: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, name: str, unit: str, scopeId: str, transientAnalysisob: TransientAnalysisJob, getScopeDataDelegate: GetScopeDataDelegate): ...

class SolverNativeBridge:
    @property
    def ErrorsAndWarnings(self, ) -> List[ErrorOrWarning]: ...
    def SetUpdateProgressDelegate(self, updateProgressDelegate: Optional[UpdateProgressDelegate] = None) -> Any: ...
    def DisposeNativeSolver(self) -> Any: ...
    def AddDevice(self, modelType: ModelType, guid: str, subcircuitGuid: Optional[str] = None, subcircuiDefinitionGuid: Optional[str] = None) -> Status: ...
    def SetDeviceParameter(self, deviceGuid: str, parameterName: str, parameter_expression: str, subcircuitGuid: Optional[str] = None) -> Status: ...
    def SetConnection(self, deviceGuid: str, pinName: str, connectorGuid: str, subcircuitGuid: Optional[str] = None) -> Status: ...
    def SetScope(self, deviceGuid: str, scopeGuid: str, scopeType: ScopeType, controlPinIndex: Optional[int] = None, subcircuitGuid: Optional[str] = None) -> Status: ...
    def ConfigureScopeMemory(self, scopeGuid: str, unique_time_scope: Optional[bool] = None) -> Status: ...
    def Solve(self) -> Status: ...
    def Stop(self) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def ClearScopesData(self, clear_all: bool, start_time: float) -> Status: ...
    def SetThermalData(self, thermalDataID: str, type: ThermalDataType, array1: DoubleArrayParameter, array2: DoubleArrayParameter, temperature: float, voltage: float) -> Status: ...
    def SetThermalDataComputationMethod(self, thermalDataID: str, thermalDataType: ThermalDataType, thermalComputationMethodType: ThermalComputationMethodType, Formula: Optional[str] = None) -> Status: ...
    def SetThermalDataCustomTable(self, thermalDataID: str, customTableName: str, axis_0: DoubleArrayParameter, axis_1: DoubleArrayParameter, axis_2: DoubleArrayParameter, data: Any) -> Status: ...
    def CheckCircuitConsistency(self) -> Status: ...
    def SetVariable(self, variable_name: str, variable_expression: str, subcircuit_definition_id: Optional[str] = None, subcircuit_instance_id: Optional[str] = None) -> Status: ...
    def SetLogLevel(self, log_type: LogType, log_level: int) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self, solverType: SolverType, updateProgressDelegate: Optional[UpdateProgressDelegate] = None): ...

class GetScopeDataDelegate:
    @property
    def Target(self, ) -> Any: ...
    @property
    def Method(self, ) -> Any: ...
    def GetObjectData(self, info: Any, context: Any) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetInvocationList(self) -> Any: ...
    def GetHashCode(self) -> int: ...
    def Clone(self) -> Any: ...
    def DynamicInvoke(self, args: Any) -> Any: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def __init__(self, object: Any, method: Any): ...

class TransientAnalysisJob:
    @property
    def TransientSolver(self, ) -> TransientSolver: ...
    @property
    def TimePoints(self, ) -> Any: ...
    @property
    def SolverType(self, ) -> SolverType: ...
    @property
    def IsTemporary(self, ) -> bool: ...
    @property
    def AnalysisProgress(self, ) -> AnalysisProgress: ...
    @property
    def AnalysisProgressInterface(self, ) -> Any: ...
    @property
    def StartTime(self, ) -> Any: ...
    @property
    def EndTime(self, ) -> Any: ...
    @property
    def RunTime(self, ) -> float: ...
    @property
    def Id(self, ) -> Any: ...
    @property
    def Name(self, ) -> str: ...
    @property
    def Annotation(self, ) -> str: ...
    @property
    def Signals(self, ) -> List[Signal]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def ClearScopesData(self) -> Status: ...
    def ClearScopesData(self, start_time: float) -> Status: ...
    def GetSignalByScopeID(self, scopeGUID: str) -> Signal: ...
    def GetSignalByName(self, signalName: str) -> Signal: ...
    def Run(self) -> Status: ...
    def SolverNativeBridgePlatform(solverType: SolverType) -> ISolverNativeBridge: ...
    def Dispose(self) -> Any: ...
    def Summary(self) -> str: ...
    def UpdateProgress(self, status: Status, progress: float, errorOrWarning: ErrorOrWarning) -> Any: ...
    def SavedInDatabase(self) -> Any: ...
    def ToString(self) -> str: ...
    def SetUpdateResultJobsHandler(self, j: UpdateResultJobsDelegate) -> Any: ...
    def GetType(self) -> Any: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, transientSolver: TransientSolver, name: str, progress: Optional[Any] = None): ...

class TransientSolver:
    @property
    def Name(self, ) -> str: ...
    @property
    def EndTime(self, ) -> DoubleParameter: ...
    @property
    def FixedTimeStep(self, ) -> bool: ...
    @property
    def SaveInitialPoint(self, ) -> bool: ...
    @property
    def CompressScopes(self, ) -> bool: ...
    @property
    def StopAtSteadyState(self, ) -> bool: ...
    @property
    def TimeStep(self, ) -> DoubleParameter: ...
    @property
    def NumberOfPointsToSimulate(self, ) -> IntParameter: ...
    @property
    def BaseFrequencyParameterEnabled(self, ) -> bool: ...
    @property
    def NumberOfBasePeriodsSavedParameterEnabled(self, ) -> bool: ...
    @property
    def BaseFrequency(self, ) -> DoubleParameter: ...
    @property
    def NumberOfBasePeriodsSaved(self, ) -> IntParameter: ...
    @property
    def Design(self, ) -> Design: ...
    @property
    def Parameters(self, ) -> List[Any]: ...
    @property
    def EntityId(self, ) -> Any: ...
    def GetNumberOfPointsToSimulate(self) -> int: ...
    def NewJob(self, progress: Optional[Any] = None) -> TransientAnalysisJob: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, expression: str) -> Status: ...
    def SetAnalysisParameter(self, parameter: SolverParameter, value: bool) -> Status: ...
    def RemoveAnalysisParameter(self, parameter: SolverParameter) -> Status: ...
    def GetType(self) -> Any: ...
    def ToString(self) -> str: ...
    def Equals(self, obj: Any) -> bool: ...
    def GetHashCode(self) -> int: ...
    def __init__(self): ...
    def __init__(self, solver: TransientSolver, design: Design): ...
    def __init__(self, d: Design): ...
